import{s as Tt,n as At,o as Mt}from"../chunks/scheduler.9039eef2.js";import{S as Lt,i as qt,g as r,s as i,p as u,A as Ht,h as n,f as t,c as h,j as p,q as c,m as d,k as s,v as l,a as o,r as m,d as f,t as v,u as g}from"../chunks/index.29f60e85.js";import{I as D}from"../chunks/IconCopyLink.75b780ad.js";import{C as Ue}from"../chunks/CodeBlock.60ec9125.js";function Et(Ge){let _,me,w,k,le,E,Ie,ee,Qe="Multi Adapter RL (MARL) - a single base model for everything",fe,j,Ke="Here we present an approach that uses a single base model for the entire PPO algorithm - which includes retrieving the reference logits, computing the active logits and the rewards. This feature is experimental as we did not tested the convergence of the approach. We encourage the community to let us know if they potentially face into any issue.",ve,b,T,ie,S,Oe,te,De="Requirements",ge,R,et="You just need to install <code>peft</code> and optionally install <code>bitsandbytes</code> as well if you want to go for 8bit base models, for more memory efficient finetuning.",_e,y,A,he,N,Ve,ae,tt="Summary",we,J,at="You need to address this approach in three stages that we summarize as follows:",be,W,rt=`1- Train a base model on the target domain (e.g. <code>imdb</code> dataset) - this is the Supervised Fine Tuning stage - it can leverage the <code>SFTTrainer</code> from TRL.
2- Train a reward model using <code>peft</code>. This is required in order to re-use the adapter during the RL optimisation process (step 3 below). We show an example of leveraging the <code>RewardTrainer</code> from TRL in <a href="https://github.com/huggingface/trl/tree/main/examples/scripts/reward_trainer.py" rel="nofollow">this example</a>
3- Fine tune new adapters on the base model using PPO and the reward adapter. (“0 abstraction RL”)`,ye,B,nt="Make sure to use the same model (i.e. same architecture and same weights) for the stages 2 & 3.",$e,$,M,pe,F,Xe,re,ot="Quickstart",xe,U,st=`Let us assume you have trained your reward adapter on <code>llama-7b</code> model using <code>RewardTrainer</code> and pushed the weights on the hub under <code>trl-lib/llama-7b-hh-rm-adapter</code>.
When doing PPO, before passing the model to <code>PPOTrainer</code> create your model as follows:`,Ce,I,Pe,O,lt="Then inside your PPO training loop, call the <code>compute_reward_score</code> method by accessing to the <code>model</code> attribute from <code>PPOTrainer</code>.",ke,V,Te,x,L,de,X,Ze,ne,it="Advanced usage",Ae,C,q,ue,Z,Ye,oe,ht="Control on the adapter name",Me,Y,pt=`If you are familiar with the <code>peft</code> library, you know that you can use multiple adapters inside the same model. What you can do is to train multiple adapters on the same base model to fine-tune on different policies.
In this case, you want to have a control on the adapter name you want to activate back, after retrieving the reward. For that, simply pass the appropriate <code>adapter_name</code> to <code>ppo_adapter_name</code> argument when calling <code>compute_reward_score</code>.`,Le,z,qe,P,H,ce,G,ze,se,dt="Using 4-bit and 8-bit base models",He,Q,ut=`For more memory efficient fine-tuning, you can load your base model in 8-bit or 4-bit while keeping the adapters in the default precision (float32).
Just pass the appropriate arguments (i.e. <code>load_in_8bit=True</code> or <code>load_in_4bit=True</code>) to <code>AutoModelForCausalLMWithValueHead.from_pretrained</code> as follows (assuming you have installed <code>bitsandbytes</code>):`,Ee,K,je;return E=new D({}),S=new D({}),N=new D({}),F=new D({}),I=new Ue({props:{code:"JTBBJTBBJTBB",highlighted:`model_name = <span class="hljs-string">&quot;huggyllama/llama-7b&quot;</span>
rm_adapter_id = <span class="hljs-string">&quot;trl-lib/llama-7b-hh-rm-adapter&quot;</span>

<span class="hljs-comment"># PPO adapter</span>
lora_config = LoraConfig(
    r=<span class="hljs-number">16</span>,
    lora_alpha=<span class="hljs-number">32</span>,
    lora_dropout=<span class="hljs-number">0.05</span>,
    bias=<span class="hljs-string">&quot;none&quot;</span>,
    task_type=<span class="hljs-string">&quot;CAUSAL_LM&quot;</span>,
)

model = AutoModelForCausalLMWithValueHead.from_pretrained(
    model_name,
    peft_config=lora_config,
    reward_adapter=rm_adapter_id,
)

...
trainer = PPOTrainer(
    model=model,
    ...
)

...`}}),V=new Ue({props:{code:"cmV3YXJkcyUyMCUzRCUyMHRyYWluZXIubW9kZWwuY29tcHV0ZV9yZXdhcmRfc2NvcmUoKippbnB1dHMp",highlighted:"rewards = trainer.model.compute_reward_score(**inputs)"}}),X=new D({}),Z=new D({}),z=new Ue({props:{code:"YWRhcHRlcl9uYW1lX3BvbGljeV8xJTIwJTNEJTIwJTIycG9saWN5XzElMjIlMEFyZXdhcmRzJTIwJTNEJTIwdHJhaW5lci5tb2RlbC5jb21wdXRlX3Jld2FyZF9zY29yZSgqKmlucHV0cyUyQyUyMHBwb19hZGFwdGVyX25hbWUlM0RhZGFwdGVyX25hbWVfcG9saWN5XzEpJTBBLi4u",highlighted:`adapter_name_policy_1 = <span class="hljs-string">&quot;policy_1&quot;</span>
rewards = trainer.model.compute_reward_score(**inputs, ppo_adapter_name=adapter_name_policy_1)
...`}}),G=new D({}),K=new Ue({props:{code:"JTBBJTBB",highlighted:`model_name = <span class="hljs-string">&quot;llama-7b&quot;</span>
rm_adapter_id = <span class="hljs-string">&quot;trl-lib/llama-7b-hh-rm-adapter&quot;</span>

<span class="hljs-comment"># PPO adapter</span>
lora_config = LoraConfig(
    r=<span class="hljs-number">16</span>,
    lora_alpha=<span class="hljs-number">32</span>,
    lora_dropout=<span class="hljs-number">0.05</span>,
    bias=<span class="hljs-string">&quot;none&quot;</span>,
    task_type=<span class="hljs-string">&quot;CAUSAL_LM&quot;</span>,
)

model = AutoModelForCausalLMWithValueHead.from_pretrained(
    model_name,
    peft_config=lora_config,
    reward_adapter=rm_adapter_id,
    load_in_8bit=<span class="hljs-literal">True</span>,
)

...
trainer = PPOTrainer(
    model=model,
    ...
)
...`}}),{c(){_=r("meta"),me=i(),w=r("h1"),k=r("a"),le=r("span"),u(E.$$.fragment),Ie=i(),ee=r("span"),ee.textContent=Qe,fe=i(),j=r("p"),j.textContent=Ke,ve=i(),b=r("h2"),T=r("a"),ie=r("span"),u(S.$$.fragment),Oe=i(),te=r("span"),te.textContent=De,ge=i(),R=r("p"),R.innerHTML=et,_e=i(),y=r("h2"),A=r("a"),he=r("span"),u(N.$$.fragment),Ve=i(),ae=r("span"),ae.textContent=tt,we=i(),J=r("p"),J.textContent=at,be=i(),W=r("p"),W.innerHTML=rt,ye=i(),B=r("p"),B.textContent=nt,$e=i(),$=r("h2"),M=r("a"),pe=r("span"),u(F.$$.fragment),Xe=i(),re=r("span"),re.textContent=ot,xe=i(),U=r("p"),U.innerHTML=st,Ce=i(),u(I.$$.fragment),Pe=i(),O=r("p"),O.innerHTML=lt,ke=i(),u(V.$$.fragment),Te=i(),x=r("h2"),L=r("a"),de=r("span"),u(X.$$.fragment),Ze=i(),ne=r("span"),ne.textContent=it,Ae=i(),C=r("h3"),q=r("a"),ue=r("span"),u(Z.$$.fragment),Ye=i(),oe=r("span"),oe.textContent=ht,Me=i(),Y=r("p"),Y.innerHTML=pt,Le=i(),u(z.$$.fragment),qe=i(),P=r("h3"),H=r("a"),ce=r("span"),u(G.$$.fragment),ze=i(),se=r("span"),se.textContent=dt,He=i(),Q=r("p"),Q.innerHTML=ut,Ee=i(),u(K.$$.fragment),this.h()},l(e){const a=Ht("svelte-1phssyn",document.head);_=n(a,"META",{name:!0,content:!0}),a.forEach(t),me=h(e),w=n(e,"H1",{class:!0});var Se=p(w);k=n(Se,"A",{id:!0,class:!0,href:!0});var ct=p(k);le=n(ct,"SPAN",{});var mt=p(le);c(E.$$.fragment,mt),mt.forEach(t),ct.forEach(t),Ie=h(Se),ee=n(Se,"SPAN",{"data-svelte-h":!0}),d(ee)!=="svelte-5chxjq"&&(ee.textContent=Qe),Se.forEach(t),fe=h(e),j=n(e,"P",{"data-svelte-h":!0}),d(j)!=="svelte-1pv53br"&&(j.textContent=Ke),ve=h(e),b=n(e,"H2",{class:!0});var Re=p(b);T=n(Re,"A",{id:!0,class:!0,href:!0});var ft=p(T);ie=n(ft,"SPAN",{});var vt=p(ie);c(S.$$.fragment,vt),vt.forEach(t),ft.forEach(t),Oe=h(Re),te=n(Re,"SPAN",{"data-svelte-h":!0}),d(te)!=="svelte-ypjn7h"&&(te.textContent=De),Re.forEach(t),ge=h(e),R=n(e,"P",{"data-svelte-h":!0}),d(R)!=="svelte-1crdfuc"&&(R.innerHTML=et),_e=h(e),y=n(e,"H2",{class:!0});var Ne=p(y);A=n(Ne,"A",{id:!0,class:!0,href:!0});var gt=p(A);he=n(gt,"SPAN",{});var _t=p(he);c(N.$$.fragment,_t),_t.forEach(t),gt.forEach(t),Ve=h(Ne),ae=n(Ne,"SPAN",{"data-svelte-h":!0}),d(ae)!=="svelte-lnd84v"&&(ae.textContent=tt),Ne.forEach(t),we=h(e),J=n(e,"P",{"data-svelte-h":!0}),d(J)!=="svelte-1nxlg56"&&(J.textContent=at),be=h(e),W=n(e,"P",{"data-svelte-h":!0}),d(W)!=="svelte-1um21to"&&(W.innerHTML=rt),ye=h(e),B=n(e,"P",{"data-svelte-h":!0}),d(B)!=="svelte-x4geit"&&(B.textContent=nt),$e=h(e),$=n(e,"H2",{class:!0});var Je=p($);M=n(Je,"A",{id:!0,class:!0,href:!0});var wt=p(M);pe=n(wt,"SPAN",{});var bt=p(pe);c(F.$$.fragment,bt),bt.forEach(t),wt.forEach(t),Xe=h(Je),re=n(Je,"SPAN",{"data-svelte-h":!0}),d(re)!=="svelte-1nw2yoa"&&(re.textContent=ot),Je.forEach(t),xe=h(e),U=n(e,"P",{"data-svelte-h":!0}),d(U)!=="svelte-yusdbc"&&(U.innerHTML=st),Ce=h(e),c(I.$$.fragment,e),Pe=h(e),O=n(e,"P",{"data-svelte-h":!0}),d(O)!=="svelte-yr7vmi"&&(O.innerHTML=lt),ke=h(e),c(V.$$.fragment,e),Te=h(e),x=n(e,"H2",{class:!0});var We=p(x);L=n(We,"A",{id:!0,class:!0,href:!0});var yt=p(L);de=n(yt,"SPAN",{});var $t=p(de);c(X.$$.fragment,$t),$t.forEach(t),yt.forEach(t),Ze=h(We),ne=n(We,"SPAN",{"data-svelte-h":!0}),d(ne)!=="svelte-psuwy"&&(ne.textContent=it),We.forEach(t),Ae=h(e),C=n(e,"H3",{class:!0});var Be=p(C);q=n(Be,"A",{id:!0,class:!0,href:!0});var xt=p(q);ue=n(xt,"SPAN",{});var Ct=p(ue);c(Z.$$.fragment,Ct),Ct.forEach(t),xt.forEach(t),Ye=h(Be),oe=n(Be,"SPAN",{"data-svelte-h":!0}),d(oe)!=="svelte-11pzn4k"&&(oe.textContent=ht),Be.forEach(t),Me=h(e),Y=n(e,"P",{"data-svelte-h":!0}),d(Y)!=="svelte-1plx0m7"&&(Y.innerHTML=pt),Le=h(e),c(z.$$.fragment,e),qe=h(e),P=n(e,"H3",{class:!0});var Fe=p(P);H=n(Fe,"A",{id:!0,class:!0,href:!0});var Pt=p(H);ce=n(Pt,"SPAN",{});var kt=p(ce);c(G.$$.fragment,kt),kt.forEach(t),Pt.forEach(t),ze=h(Fe),se=n(Fe,"SPAN",{"data-svelte-h":!0}),d(se)!=="svelte-1wpqk3n"&&(se.textContent=dt),Fe.forEach(t),He=h(e),Q=n(e,"P",{"data-svelte-h":!0}),d(Q)!=="svelte-17i0flk"&&(Q.innerHTML=ut),Ee=h(e),c(K.$$.fragment,e),this.h()},h(){s(_,"name","hf:doc:metadata"),s(_,"content",JSON.stringify(jt)),s(k,"id","multi-adapter-rl-marl-a-single-base-model-for-everything"),s(k,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(k,"href","#multi-adapter-rl-marl-a-single-base-model-for-everything"),s(w,"class","relative group"),s(T,"id","requirements"),s(T,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(T,"href","#requirements"),s(b,"class","relative group"),s(A,"id","summary"),s(A,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(A,"href","#summary"),s(y,"class","relative group"),s(M,"id","quickstart"),s(M,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(M,"href","#quickstart"),s($,"class","relative group"),s(L,"id","advanced-usage"),s(L,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(L,"href","#advanced-usage"),s(x,"class","relative group"),s(q,"id","control-on-the-adapter-name"),s(q,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(q,"href","#control-on-the-adapter-name"),s(C,"class","relative group"),s(H,"id","using-4bit-and-8bit-base-models"),s(H,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(H,"href","#using-4bit-and-8bit-base-models"),s(P,"class","relative group")},m(e,a){l(document.head,_),o(e,me,a),o(e,w,a),l(w,k),l(k,le),m(E,le,null),l(w,Ie),l(w,ee),o(e,fe,a),o(e,j,a),o(e,ve,a),o(e,b,a),l(b,T),l(T,ie),m(S,ie,null),l(b,Oe),l(b,te),o(e,ge,a),o(e,R,a),o(e,_e,a),o(e,y,a),l(y,A),l(A,he),m(N,he,null),l(y,Ve),l(y,ae),o(e,we,a),o(e,J,a),o(e,be,a),o(e,W,a),o(e,ye,a),o(e,B,a),o(e,$e,a),o(e,$,a),l($,M),l(M,pe),m(F,pe,null),l($,Xe),l($,re),o(e,xe,a),o(e,U,a),o(e,Ce,a),m(I,e,a),o(e,Pe,a),o(e,O,a),o(e,ke,a),m(V,e,a),o(e,Te,a),o(e,x,a),l(x,L),l(L,de),m(X,de,null),l(x,Ze),l(x,ne),o(e,Ae,a),o(e,C,a),l(C,q),l(q,ue),m(Z,ue,null),l(C,Ye),l(C,oe),o(e,Me,a),o(e,Y,a),o(e,Le,a),m(z,e,a),o(e,qe,a),o(e,P,a),l(P,H),l(H,ce),m(G,ce,null),l(P,ze),l(P,se),o(e,He,a),o(e,Q,a),o(e,Ee,a),m(K,e,a),je=!0},p:At,i(e){je||(f(E.$$.fragment,e),f(S.$$.fragment,e),f(N.$$.fragment,e),f(F.$$.fragment,e),f(I.$$.fragment,e),f(V.$$.fragment,e),f(X.$$.fragment,e),f(Z.$$.fragment,e),f(z.$$.fragment,e),f(G.$$.fragment,e),f(K.$$.fragment,e),je=!0)},o(e){v(E.$$.fragment,e),v(S.$$.fragment,e),v(N.$$.fragment,e),v(F.$$.fragment,e),v(I.$$.fragment,e),v(V.$$.fragment,e),v(X.$$.fragment,e),v(Z.$$.fragment,e),v(z.$$.fragment,e),v(G.$$.fragment,e),v(K.$$.fragment,e),je=!1},d(e){e&&(t(me),t(w),t(fe),t(j),t(ve),t(b),t(ge),t(R),t(_e),t(y),t(we),t(J),t(be),t(W),t(ye),t(B),t($e),t($),t(xe),t(U),t(Ce),t(Pe),t(O),t(ke),t(Te),t(x),t(Ae),t(C),t(Me),t(Y),t(Le),t(qe),t(P),t(He),t(Q),t(Ee)),t(_),g(E),g(S),g(N),g(F),g(I,e),g(V,e),g(X),g(Z),g(z,e),g(G),g(K,e)}}}const jt={local:"multi-adapter-rl-marl-a-single-base-model-for-everything",sections:[{local:"requirements",title:"Requirements"},{local:"summary",title:"Summary"},{local:"quickstart",title:"Quickstart"},{local:"advanced-usage",sections:[{local:"control-on-the-adapter-name",title:"Control on the adapter name "},{local:"using-4bit-and-8bit-base-models",title:"Using 4-bit and 8-bit base models"}],title:"Advanced usage"}],title:"Multi Adapter RL (MARL) - a single base model for everything"};function St(Ge){return Mt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Bt extends Lt{constructor(_){super(),qt(this,_,St,Et,Tt,{})}}export{Bt as component};
