import{s as Gt,n as It,o as Nt}from"../chunks/scheduler.9039eef2.js";import{S as Ft,i as jt,g as a,s as r,p as N,A as Zt,h as o,f as e,c,j as h,q as F,m as p,k as s,v as i,a as l,r as j,d as Z,t as q,u as B}from"../chunks/index.29f60e85.js";import{I as ht}from"../chunks/IconCopyLink.75b780ad.js";import{C as Ut}from"../chunks/CodeBlock.60ec9125.js";function qt(ft){let u,R,d,v,J,$,pt,L,gt="Sentiment Examples",D,_,vt="The notebooks and scripts in this examples show how to fine-tune a model with a sentiment classifier (such as <code>lvwerra/distilbert-imdb</code>).",z,x,bt='Here’s an overview of the notebooks and scripts in the <a href="https://github.com/huggingface/trl/tree/main/examples" rel="nofollow">trl repository</a>:',O,k,wt='<thead><tr><th>File</th> <th>Description</th> <th>Colab link</th></tr></thead> <tbody><tr><td><a href="https://github.com/huggingface/trl/blob/main/examples/notebooks/gpt2-sentiment.ipynb" rel="nofollow"><code>gpt2-sentiment.ipynb</code></a></td> <td>Fine-tune GPT2 to generate positive movie reviews.</td> <td><a href="https://colab.research.google.com/github/huggingface/trl/blob/main/examples/sentiment/notebooks/gpt2-sentiment.ipynb" rel="nofollow"><img src="https://colab.research.google.com/assets/colab-badge.svg" alt="Open In Colab"/></a></td></tr> <tr><td></td> <td></td> <td></td></tr> <tr><td><a href="https://github.com/huggingface/trl/blob/main/examples/notebooks/gpt2-sentiment-control.ipynb" rel="nofollow"><code>gpt2-sentiment-control.ipynb</code></a></td> <td>Fine-tune GPT2 to generate movie reviews with controlled sentiment.</td> <td><a href="https://colab.research.google.com/github/huggingface/trl/blob/main/examples/sentiment/notebooks/gpt2-sentiment-control.ipynb" rel="nofollow"><img src="https://colab.research.google.com/assets/colab-badge.svg" alt="Open In Colab"/></a></td></tr> <tr><td></td> <td></td> <td></td></tr> <tr><td><a href="https://github.com/huggingface/trl/blob/main/examples/ppo_trainer/sentiment_tuning.py" rel="nofollow"><code>gpt2-sentiment.py</code></a></td> <td>Same as the notebook, but easier to use to use in multi-GPU setup with any architecture.</td> <td>x</td></tr></tbody>',Q,m,b,Y,M,ut,U,yt="Installation",V,C,K,T,$t='Note: if you don’t want to log with <code>wandb</code> remove <code>log_with=&quot;wandb&quot;</code> in the scripts/notebooks. You can also replace it with your favourite experiment tracker that’s <a href="https://huggingface.co/docs/accelerate/usage_guides/tracking" rel="nofollow">supported by <code>accelerate</code></a>.',tt,f,w,W,P,dt,G,_t="Launch scripts",et,H,xt="The <code>trl</code> library is powered by <code>accelerate</code>. As such it is best to configure and launch trainings with the following commands:",nt,S,at,g,y,X,A,mt,I,kt="Few notes on multi-GPU",ot,E,Mt="To run in multi-GPU setup with DDP (distributed Data Parallel) change the <code>device_map</code> value to <code>device_map={&quot;&quot;: Accelerator().process_index}</code> and make sure to run your script with <code>accelerate launch yourscript.py</code>. If you want to apply naive pipeline parallelism you can use <code>device_map=&quot;auto&quot;</code>.",lt;return $=new ht({}),M=new ht({}),C=new Ut({props:{code:"cGlwJTIwaW5zdGFsbCUyMHRybCUwQSUyM29wdGlvbmFsJTNBJTIwd2FuZGIlMEFwaXAlMjBpbnN0YWxsJTIwd2FuZGI=",highlighted:`pip install trl
<span class="hljs-comment">#optional: wandb</span>
pip install wandb`}}),P=new ht({}),S=new Ut({props:{code:"YWNjZWxlcmF0ZSUyMGNvbmZpZyUyMCUyMyUyMHdpbGwlMjBwcm9tcHQlMjB5b3UlMjB0byUyMGRlZmluZSUyMHRoZSUyMHRyYWluaW5nJTIwY29uZmlndXJhdGlvbiUwQWFjY2VsZXJhdGUlMjBsYXVuY2glMjB5b3Vyc2NyaXB0LnB5JTIwJTIzJTIwbGF1bmNoZXMlMjB0cmFpbmluZw==",highlighted:`accelerate config <span class="hljs-comment"># will prompt you to define the training configuration</span>
accelerate launch yourscript.py <span class="hljs-comment"># launches training</span>`}}),A=new ht({}),{c(){u=a("meta"),R=r(),d=a("h1"),v=a("a"),J=a("span"),N($.$$.fragment),pt=r(),L=a("span"),L.textContent=gt,D=r(),_=a("p"),_.innerHTML=vt,z=r(),x=a("p"),x.innerHTML=bt,O=r(),k=a("table"),k.innerHTML=wt,Q=r(),m=a("h2"),b=a("a"),Y=a("span"),N(M.$$.fragment),ut=r(),U=a("span"),U.textContent=yt,V=r(),N(C.$$.fragment),K=r(),T=a("p"),T.innerHTML=$t,tt=r(),f=a("h2"),w=a("a"),W=a("span"),N(P.$$.fragment),dt=r(),G=a("span"),G.textContent=_t,et=r(),H=a("p"),H.innerHTML=xt,nt=r(),N(S.$$.fragment),at=r(),g=a("h2"),y=a("a"),X=a("span"),N(A.$$.fragment),mt=r(),I=a("span"),I.textContent=kt,ot=r(),E=a("p"),E.innerHTML=Mt,this.h()},l(t){const n=Zt("svelte-1phssyn",document.head);u=o(n,"META",{name:!0,content:!0}),n.forEach(e),R=c(t),d=o(t,"H1",{class:!0});var st=h(d);v=o(st,"A",{id:!0,class:!0,href:!0});var Ct=h(v);J=o(Ct,"SPAN",{});var Tt=h(J);F($.$$.fragment,Tt),Tt.forEach(e),Ct.forEach(e),pt=c(st),L=o(st,"SPAN",{"data-svelte-h":!0}),p(L)!=="svelte-1vf0bd9"&&(L.textContent=gt),st.forEach(e),D=c(t),_=o(t,"P",{"data-svelte-h":!0}),p(_)!=="svelte-fb2yxu"&&(_.innerHTML=vt),z=c(t),x=o(t,"P",{"data-svelte-h":!0}),p(x)!=="svelte-k5thfi"&&(x.innerHTML=bt),O=c(t),k=o(t,"TABLE",{"data-svelte-h":!0}),p(k)!=="svelte-1yik3ti"&&(k.innerHTML=wt),Q=c(t),m=o(t,"H2",{class:!0});var it=h(m);b=o(it,"A",{id:!0,class:!0,href:!0});var Pt=h(b);Y=o(Pt,"SPAN",{});var Ht=h(Y);F(M.$$.fragment,Ht),Ht.forEach(e),Pt.forEach(e),ut=c(it),U=o(it,"SPAN",{"data-svelte-h":!0}),p(U)!=="svelte-99g31l"&&(U.textContent=yt),it.forEach(e),V=c(t),F(C.$$.fragment,t),K=c(t),T=o(t,"P",{"data-svelte-h":!0}),p(T)!=="svelte-vkwr34"&&(T.innerHTML=$t),tt=c(t),f=o(t,"H2",{class:!0});var rt=h(f);w=o(rt,"A",{id:!0,class:!0,href:!0});var St=h(w);W=o(St,"SPAN",{});var At=h(W);F(P.$$.fragment,At),At.forEach(e),St.forEach(e),dt=c(rt),G=o(rt,"SPAN",{"data-svelte-h":!0}),p(G)!=="svelte-ratvi8"&&(G.textContent=_t),rt.forEach(e),et=c(t),H=o(t,"P",{"data-svelte-h":!0}),p(H)!=="svelte-1dq9zm0"&&(H.innerHTML=xt),nt=c(t),F(S.$$.fragment,t),at=c(t),g=o(t,"H2",{class:!0});var ct=h(g);y=o(ct,"A",{id:!0,class:!0,href:!0});var Et=h(y);X=o(Et,"SPAN",{});var Lt=h(X);F(A.$$.fragment,Lt),Lt.forEach(e),Et.forEach(e),mt=c(ct),I=o(ct,"SPAN",{"data-svelte-h":!0}),p(I)!=="svelte-f8qvql"&&(I.textContent=kt),ct.forEach(e),ot=c(t),E=o(t,"P",{"data-svelte-h":!0}),p(E)!=="svelte-qlov4x"&&(E.innerHTML=Mt),this.h()},h(){s(u,"name","hf:doc:metadata"),s(u,"content",JSON.stringify(Bt)),s(v,"id","sentiment-examples"),s(v,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(v,"href","#sentiment-examples"),s(d,"class","relative group"),s(b,"id","installation"),s(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(b,"href","#installation"),s(m,"class","relative group"),s(w,"id","launch-scripts"),s(w,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(w,"href","#launch-scripts"),s(f,"class","relative group"),s(y,"id","few-notes-on-multigpu"),s(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(y,"href","#few-notes-on-multigpu"),s(g,"class","relative group")},m(t,n){i(document.head,u),l(t,R,n),l(t,d,n),i(d,v),i(v,J),j($,J,null),i(d,pt),i(d,L),l(t,D,n),l(t,_,n),l(t,z,n),l(t,x,n),l(t,O,n),l(t,k,n),l(t,Q,n),l(t,m,n),i(m,b),i(b,Y),j(M,Y,null),i(m,ut),i(m,U),l(t,V,n),j(C,t,n),l(t,K,n),l(t,T,n),l(t,tt,n),l(t,f,n),i(f,w),i(w,W),j(P,W,null),i(f,dt),i(f,G),l(t,et,n),l(t,H,n),l(t,nt,n),j(S,t,n),l(t,at,n),l(t,g,n),i(g,y),i(y,X),j(A,X,null),i(g,mt),i(g,I),l(t,ot,n),l(t,E,n),lt=!0},p:It,i(t){lt||(Z($.$$.fragment,t),Z(M.$$.fragment,t),Z(C.$$.fragment,t),Z(P.$$.fragment,t),Z(S.$$.fragment,t),Z(A.$$.fragment,t),lt=!0)},o(t){q($.$$.fragment,t),q(M.$$.fragment,t),q(C.$$.fragment,t),q(P.$$.fragment,t),q(S.$$.fragment,t),q(A.$$.fragment,t),lt=!1},d(t){t&&(e(R),e(d),e(D),e(_),e(z),e(x),e(O),e(k),e(Q),e(m),e(V),e(K),e(T),e(tt),e(f),e(et),e(H),e(nt),e(at),e(g),e(ot),e(E)),e(u),B($),B(M),B(C,t),B(P),B(S,t),B(A)}}}const Bt={local:"sentiment-examples",sections:[{local:"installation",title:"Installation"},{local:"launch-scripts",title:"Launch scripts"},{local:"few-notes-on-multigpu",title:"Few notes on multi-GPU "}],title:"Sentiment Examples"};function Jt(ft){return Nt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Dt extends Ft{constructor(u){super(),jt(this,u,Jt,qt,Gt,{})}}export{Dt as component};
