import{s as Go,n as Jo,o as Yo}from"../chunks/scheduler.9039eef2.js";import{S as Zo,i as Qo,g as n,s as o,p,A as Xo,h as a,f as r,c as s,j as l,q as m,m as d,k as i,v as t,a as g,r as h,d as _,t as u,u as f}from"../chunks/index.29f60e85.js";import{D as b}from"../chunks/Docstring.1155cb0e.js";import{I as L}from"../chunks/IconCopyLink.75b780ad.js";function es(Lr){let z,fn,F,K,sn,Pe,ua,dt,zr="Trainer",vn,xe,Fr=`At TRL we support PPO (Proximal Policy Optimisation) with an implementation that largely follows  the structure introduced in the paper “Fine-Tuning Language Models from Human Preferences” by D. Ziegler et al. [<a href="https://arxiv.org/pdf/1909.08593.pdf" rel="nofollow">paper</a>, <a href="https://github.com/openai/lm-human-preferences" rel="nofollow">code</a>].
The Trainer and model classes are largely inspired from <code>transformers.Trainer</code> and <code>transformers.AutoModel</code> classes and adapted for RL.
We also support a <code>RewardTrainer</code> that can be used to train a reward model.`,bn,A,G,ln,Oe,fa,ct,Ar="PPOConfig",Tn,S,$e,va,pt,Sr="Configuration class for PPOTrainer",yn,q,J,dn,we,ba,mt,qr="PPOTrainer",Pn,v,De,Ta,gt,Mr=`The PPOTrainer uses Proximal Policy Optimization to optimise language models.
Note, this trainer is heavily inspired by the original OpenAI learning to summarize work here:
<a href="https://github.com/openai/summarize-from-feedback" rel="nofollow">https://github.com/openai/summarize-from-feedback</a>`,ya,Y,Ce,Pa,ht,Er="Calculate model outputs in multiple batches.",xa,Z,ke,Oa,_t,Ir="Compute per token rewards from scores and KL-penalty.",$a,Q,Ne,wa,ut,Hr="Creates and saves a model card for a TRL model.",Da,X,Le,Ca,ft,Ur="Gather stats from all processes. Useful in the context of distributed training.",ka,ee,ze,Na,vt,Rr=`Generate response with the model given the query tensor.
call the <code>generate</code> method of the model.`,La,te,Fe,za,bt,Vr="A function that logs all the training stats. Call it at the end of each epoch.",Fa,ne,Ae,Aa,Tt,jr="Calculate policy and value losses.",Sa,ae,Se,qa,yt,Wr="Prepare the dataloader for training.",Ma,re,qe,Ea,Pt,Br="Record training step statistics.",Ia,oe,Me,Ha,xt,Kr="Run a PPO optimisation step given a list of queries, model responses, and rewards.",Ua,se,Ee,Ra,Ot,Gr="Train one PPO minibatch",xn,M,ie,cn,Ie,Va,$t,Jr="RewardConfig",On,w,He,ja,wt,Yr='RewardConfig collects all training arguments related to the <a href="/docs/trl/main/en/trainer#trl.RewardTrainer">RewardTrainer</a> class.',Wa,Dt,Zr=`Using <code>HfArgumentParser</code> we can turn this class into
<a href="https://docs.python.org/3/library/argparse#module-argparse" rel="nofollow">argparse</a> arguments that can be specified on the
command line.`,$n,E,le,pn,Ue,Ba,Ct,Qr="RewardTrainer",wn,x,Re,Ka,kt,Xr=`The RewardTrainer can be used to train your custom Reward Model. It is a subclass of the
<code>transformers.Trainer</code> class and inherits all of its attributes and methods. It is recommended to use
an <code>AutoModelForSequenceClassification</code> as the reward model. The reward model should be trained on a dataset
of paired examples, where each example is a tuple of two sequences. The reward model should be trained to
predict which example in the pair is more relevant to the task at hand.`,Ga,Nt,eo=`The reward trainer expects a very specific format for the dataset. The dataset should contain two 4 entries at least
if you don’t use the default <code>RewardDataCollatorWithPadding</code> data collator. The entries should be named`,Ja,Lt,to="<li><code>input_ids_chosen</code></li> <li><code>attention_mask_chosen</code></li> <li><code>input_ids_rejected</code></li> <li><code>attention_mask_rejected</code></li>",Ya,zt,no=`Optionally, you can also pass a <code>margin</code> entry to the dataset. This entry should contain the margin used to modulate the
loss of the reward model as outlined in <a href="https://ai.meta.com/research/publications/llama-2-open-foundation-and-fine-tuned-chat-models/" rel="nofollow">https://ai.meta.com/research/publications/llama-2-open-foundation-and-fine-tuned-chat-models/</a>.
If you don’t pass a margin, no margin will be used.`,Dn,I,de,mn,Ve,Za,Ft,ao="SFTTrainer",Cn,H,je,Qa,At,ro=`Class definition of the Supervised Finetuning Trainer (SFT Trainer).
This class is a wrapper around the <code>transformers.Trainer</code> class and inherits all of its attributes and methods.
The trainer takes care of properly initializing the PeftModel in case a user passes a <code>PeftConfig</code> object.`,kn,U,ce,gn,We,Xa,St,oo="DPOTrainer",Nn,y,Be,er,qt,so="Initialize DPOTrainer.",tr,D,Ke,nr,Mt,io="Run the given model on the given batch of inputs, concatenating the chosen and rejected inputs together.",ar,Et,lo="We do this to avoid doing two forward passes, because it’s faster for FSDP.",rr,pe,Ge,or,It,co="Concatenate the chosen and rejected inputs into a single tensor.",sr,me,Je,ir,Ht,po="Compute the DPO loss for a batch of policy and reference model log probabilities.",lr,C,Ye,dr,Ut,mo=`Overriding built-in evaluation loop to store metrics for each batch.
Prediction/evaluation loop, shared by <code>Trainer.evaluate()</code> and <code>Trainer.predict()</code>.`,cr,Rt,go="Works both with or without labels.",pr,ge,Ze,mr,Vt,ho="Compute the DPO loss and other metrics for the given batch of inputs for train or test.",gr,he,Qe,hr,jt,_o="Generate samples from the model and reference model for the given batch of inputs.",_r,_e,Xe,ur,Wt,uo="Log <code>logs</code> on the various objects watching training, including stored metrics.",Ln,R,ue,hn,et,fr,Bt,fo="DDPOConfig",zn,V,tt,vr,Kt,vo="Configuration class for DDPOTrainer",Fn,j,fe,_n,nt,br,Gt,bo="DDPOTrainer",An,O,at,Tr,Jt,To=`The DDPOTrainer uses Deep Diffusion Policy Optimization to optimise diffusion models.
Note, this trainer is heavily inspired by the work here: <a href="https://github.com/kvablack/ddpo-pytorch" rel="nofollow">https://github.com/kvablack/ddpo-pytorch</a>
As of now only Stable Diffusion based pipelines are supported`,yr,ve,rt,Pr,Yt,yo="Calculate the loss for a batch of an unpacked sample",xr,$,ot,Or,Zt,Po="Perform a single step of training.",$r,Qt,xo="Side Effects:",wr,Xt,Oo="<li>Model weights are updated</li> <li>Logs the statistics to the accelerator trackers.</li> <li>If <code>self.image_samples_callback</code> is not None, it will be called with the prompt_image_pairs, global_step, and the accelerator tracker.</li>",Dr,be,st,Cr,en,$o="Train the model for a given number of epochs",Sn,W,Te,un,it,kr,tn,wo="set_seed",qn,B,lt,Nr,nn,Do="Helper function for reproducible behavior to set the seed in <code>random</code>, <code>numpy</code>, and <code>torch</code>.",Mn;return Pe=new L({}),Oe=new L({}),$e=new b({props:{name:"class trl.PPOConfig",anchor:"trl.PPOConfig",parameters:[{name:"exp_name",val:": str = 'doc-buil'"},{name:"task_name",val:": typing.Optional[str] = None"},{name:"model_name",val:": typing.Optional[str] = None"},{name:"query_dataset",val:": typing.Optional[str] = None"},{name:"reward_model",val:": typing.Optional[str] = None"},{name:"steps",val:": int = 20000"},{name:"learning_rate",val:": float = 1e-05"},{name:"adap_kl_ctrl",val:": bool = True"},{name:"init_kl_coef",val:": typing.Optional[float] = 0.2"},{name:"kl_penalty",val:": typing.Literal['kl', 'abs', 'mse', 'full'] = 'kl'"},{name:"target",val:": typing.Optional[float] = 6"},{name:"horizon",val:": typing.Optional[float] = 10000"},{name:"gamma",val:": float = 1"},{name:"lam",val:": float = 0.95"},{name:"cliprange",val:": float = 0.2"},{name:"cliprange_value",val:": float = 0.2"},{name:"vf_coef",val:": float = 0.1"},{name:"batch_size",val:": int = 256"},{name:"forward_batch_size",val:": typing.Optional[int] = None"},{name:"mini_batch_size",val:": int = 1"},{name:"gradient_accumulation_steps",val:": int = 1"},{name:"world_size",val:": typing_extensions.Annotated[int, Suppress] = None"},{name:"backward_batch_size",val:": typing_extensions.Annotated[int, Suppress] = None"},{name:"global_backward_batch_size",val:": typing_extensions.Annotated[int, Suppress] = None"},{name:"global_batch_size",val:": typing_extensions.Annotated[int, Suppress] = None"},{name:"ppo_epochs",val:": int = 4"},{name:"remove_unused_columns",val:": bool = True"},{name:"log_with",val:": typing.Union[typing.Literal['wandb', 'tensorboard'], NoneType] = None"},{name:"tracker_kwargs",val:": dict = <factory>"},{name:"accelerator_kwargs",val:": dict = <factory>"},{name:"project_kwargs",val:": dict = <factory>"},{name:"tracker_project_name",val:": str = 'trl'"},{name:"max_grad_norm",val:": typing.Optional[float] = None"},{name:"seed",val:": int = 0"},{name:"optimize_cuda_cache",val:": bool = False"},{name:"early_stopping",val:": bool = False"},{name:"target_kl",val:": float = 1"},{name:"push_to_hub_if_best_kwargs",val:": dict = <factory>"},{name:"compare_steps",val:": int = 1"},{name:"ratio_threshold",val:": float = 10.0"},{name:"use_score_scaling",val:": bool = False"},{name:"use_score_norm",val:": bool = False"},{name:"score_clip",val:": typing.Optional[float] = None"},{name:"is_encoder_decoder",val:": typing.Union[typing_extensions.Annotated[bool, Suppress], NoneType] = None"},{name:"is_peft_model",val:": typing.Union[typing_extensions.Annotated[bool, Suppress], NoneType] = None"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_config.py#L30"}}),we=new L({}),De=new b({props:{name:"class trl.PPOTrainer",anchor:"trl.PPOTrainer",parameters:[{name:"config",val:": PPOConfig = None"},{name:"model",val:": PreTrainedModelWrapper = None"},{name:"ref_model",val:": typing.Optional[trl.models.modeling_base.PreTrainedModelWrapper] = None"},{name:"tokenizer",val:": PreTrainedTokenizerBase = None"},{name:"dataset",val:": typing.Union[torch.utils.data.dataset.Dataset, datasets.arrow_dataset.Dataset, NoneType] = None"},{name:"optimizer",val:": typing.Optional[torch.optim.optimizer.Optimizer] = None"},{name:"data_collator",val:": typing.Optional[typing.Callable] = None"},{name:"num_shared_layers",val:": typing.Optional[int] = None"},{name:"lr_scheduler",val:": typing.Optional[torch.optim.lr_scheduler._LRScheduler] = None"}],parametersDescription:[{anchor:"trl.PPOTrainer.*config**",description:`*<strong>*config**</strong> (<code>PPOConfig</code>) &#x2014; Configuration object for PPOTrainer. Check the documentation of <code>PPOConfig</code> for more &#x2014;
details.`,name:"*config**"},{anchor:"trl.PPOTrainer.*model**",description:`*<strong>*model**</strong> (<code>PreTrainedModelWrapper</code>) &#x2014; Model to be optimized, Hugging Face transformer model with a value head. &#x2014;
Check the documentation of <code>PreTrainedModelWrapper</code> for more details.`,name:"*model**"},{anchor:"trl.PPOTrainer.*ref_model**",description:`*<strong>*ref_model**</strong> (<code>PreTrainedModelWrapper</code>, <em>optional</em>) &#x2014; Reference model to be used for KL penalty, Hugging Face &#x2014;
transformer model with a casual language modelling head. Check the documentation of <code>PreTrainedModelWrapper</code>
for more details. If no reference model is provided, the trainer will create a reference model with the same
architecture as the model to be optimized with shared layers.`,name:"*ref_model**"},{anchor:"trl.PPOTrainer.*tokenizer**",description:`*<strong>*tokenizer**</strong> (<code>PreTrainedTokenizerBase</code>) &#x2014; Tokenizer to be used for encoding the &#x2014;
data. Check the documentation of <code>transformers.PreTrainedTokenizer</code> and
<code>transformers.PreTrainedTokenizerFast</code> for more details.`,name:"*tokenizer**"},{anchor:"trl.PPOTrainer.*dataset**",description:`*<strong>*dataset**</strong> (Union[<code>torch.utils.data.Dataset</code>, <code>datasets.Dataset</code>], <em>optional</em>) &#x2014; PyTorch dataset or Hugging &#x2014;
Face dataset. This is used to create a PyTorch dataloader. If no dataset is provided, the dataloader must be
created outside the trainer users needs to design their own dataloader and make sure the batch
size that is used is the same as the one specified in the configuration object.`,name:"*dataset**"},{anchor:"trl.PPOTrainer.*optimizer**",description:`*<strong>*optimizer**</strong> (<code>torch.optim.Optimizer</code>, <em>optional</em>) &#x2014; Optimizer to be used for training. If no optimizer is &#x2014;
provided, the trainer will create an Adam optimizer with the learning rate specified in the configuration
object.`,name:"*optimizer**"},{anchor:"trl.PPOTrainer.*data_collator**",description:`*<strong>*data_collator**</strong> (DataCollatorForLanguageModeling, <em>optional</em>) &#x2014; Data collator to be used for training and &#x2014;
passed along the dataloader`,name:"*data_collator**"},{anchor:"trl.PPOTrainer.*num_shared_layers**",description:`*<strong>*num_shared_layers**</strong> (int, <em>optional</em>) &#x2014; Number of layers to be shared between the model and the reference &#x2014;
model, if no reference model is passed. If no number is provided, all the layers will be shared.`,name:"*num_shared_layers**"},{anchor:"trl.PPOTrainer.*lr_scheduler**",description:"*<strong>*lr_scheduler**</strong> (<code>torch.optim.lr_scheduler</code>, <em>optional</em>) &#x2014; Learning rate scheduler to be used for training. &#x2014;",name:"*lr_scheduler**"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L107"}}),Ce=new b({props:{name:"batched_forward_pass",anchor:"trl.PPOTrainer.batched_forward_pass",parameters:[{name:"model",val:": PreTrainedModelWrapper"},{name:"queries",val:": Tensor"},{name:"responses",val:": Tensor"},{name:"model_inputs",val:": dict"},{name:"return_logits",val:": bool = False"},{name:"response_masks",val:": typing.Optional[torch.Tensor] = None"}],parametersDescription:[{anchor:"trl.PPOTrainer.batched_forward_pass.queries",description:`<strong>queries</strong> (<code>torch.LongTensor</code>) &#x2014;
List of tensors containing the encoded queries, shape (<code>batch_size</code>, <code>query_length</code>)`,name:"queries"},{anchor:"trl.PPOTrainer.batched_forward_pass.responses",description:`<strong>responses</strong> (<code>torch.LongTensor</code>) &#x2014;
List of tensors containing the encoded responses, shape (<code>batch_size</code>, <code>response_length</code>)`,name:"responses"},{anchor:"trl.PPOTrainer.batched_forward_pass.return_logits",description:`<strong>return_logits</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to return all_logits. Set to <code>False</code> if logits are not needed to reduce memory consumption.`,name:"return_logits"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L912",returnDescription:`
<ul>
<li>all_logprobs (<code>torch.FloatTensor</code>): Log probabilities of the responses,
shape (<code>batch_size</code>, <code>response_length</code>)</li>
<li>all_ref_logprobs (<code>torch.FloatTensor</code>): Log probabilities of the responses,
shape (<code>batch_size</code>, <code>response_length</code>)</li>
<li>all_values (<code>torch.FloatTensor</code>): Values of the responses, shape (<code>batch_size</code>, <code>response_length</code>)</li>
</ul>
`,returnType:`
<p>(tuple)</p>
`}}),ke=new b({props:{name:"compute_rewards",anchor:"trl.PPOTrainer.compute_rewards",parameters:[{name:"scores",val:": FloatTensor"},{name:"logprobs",val:": FloatTensor"},{name:"ref_logprobs",val:": FloatTensor"},{name:"masks",val:": LongTensor"}],parametersDescription:[{anchor:"trl.PPOTrainer.compute_rewards.scores",description:`<strong>scores</strong> (<code>torch.FloatTensor</code>) &#x2014;
Scores from the reward model, shape (<code>batch_size</code>)`,name:"scores"},{anchor:"trl.PPOTrainer.compute_rewards.logprobs",description:`<strong>logprobs</strong> (<code>torch.FloatTensor</code>) &#x2014;
Log probabilities of the model, shape (<code>batch_size</code>, <code>response_length</code>)`,name:"logprobs"},{anchor:"trl.PPOTrainer.compute_rewards.ref_logprobs",description:`<strong>ref_logprobs</strong> (<code>torch.FloatTensor</code>) &#x2014;
Log probabilities of the reference model, shape (<code>batch_size</code>, <code>response_length</code>)`,name:"ref_logprobs"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L1049"}}),Ne=new b({props:{name:"create_model_card",anchor:"trl.PPOTrainer.create_model_card",parameters:[{name:"path",val:": str"},{name:"model_name",val:": typing.Optional[str] = 'TRL Model'"}],parametersDescription:[{anchor:"trl.PPOTrainer.create_model_card.path",description:"<strong>path</strong> (<code>str</code>) &#x2014; The path to save the model card to.",name:"path"},{anchor:"trl.PPOTrainer.create_model_card.model_name",description:"<strong>model_name</strong> (<code>str</code>, <em>optional</em>) &#x2014; The name of the model, defaults to <code>TRL Model</code>.",name:"model_name"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L1355"}}),Le=new b({props:{name:"gather_stats",anchor:"trl.PPOTrainer.gather_stats",parameters:[{name:"stats",val:""}],parametersDescription:[{anchor:"trl.PPOTrainer.gather_stats.stats",description:"<strong>stats</strong> (dict[str, Any]) &#x2014;",name:"stats"},{anchor:"trl.PPOTrainer.gather_stats.a",description:"<strong>a</strong> dictionary of stats to be gathered. The stats should contain torch tensors. &#x2014;",name:"a"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L868",returnDescription:`
<p>A dictionary of stats with the tensors gathered.</p>
`,returnType:`
<p><code>dict[str, Any]</code></p>
`}}),ze=new b({props:{name:"generate",anchor:"trl.PPOTrainer.generate",parameters:[{name:"query_tensor",val:": typing.Union[torch.Tensor, typing.List[torch.Tensor]]"},{name:"length_sampler",val:": typing.Callable = None"},{name:"batch_size",val:": int = 4"},{name:"return_prompt",val:": bool = True"},{name:"**generation_kwargs",val:""}],parametersDescription:[{anchor:"trl.PPOTrainer.generate.query_tensor",description:`<strong>query_tensor</strong> (<code>torch.LongTensor</code>) &#x2014;
A tensor of shape (<code>seq_len</code>) containing query tokens or a list of tensors of shape (<code>seq_len</code>).`,name:"query_tensor"},{anchor:"trl.PPOTrainer.generate.generation_kwargs",description:`<strong>generation_kwargs</strong> (dict[str, Any]) &#x2014;
Keyword arguments for generation.`,name:"generation_kwargs"},{anchor:"trl.PPOTrainer.generate.length_sampler",description:`<strong>length_sampler</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
Callable that returns the number of newly generated tokens.`,name:"length_sampler"},{anchor:"trl.PPOTrainer.generate.batch_size",description:`<strong>batch_size</strong> (<code>int</code>, *optional) &#x2014;
Batch size used for generation, defaults to <code>4</code>.`,name:"batch_size"},{anchor:"trl.PPOTrainer.generate.return_prompt",description:`<strong>return_prompt</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>False</code> the prompt is not returned but only the newly generated tokens, defaults to <code>True</code>.`,name:"return_prompt"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L417",returnDescription:`
<p>A tensor of shape (<code>batch_size</code>, <code>gen_len</code>) containing response tokens.</p>
`,returnType:`
<p><code>torch.LongTensor</code></p>
`}}),Fe=new b({props:{name:"log_stats",anchor:"trl.PPOTrainer.log_stats",parameters:[{name:"stats",val:": dict"},{name:"batch",val:": dict"},{name:"rewards",val:": typing.List[torch.FloatTensor]"},{name:"columns_to_log",val:": typing.List[str] = ['query', 'response']"}],parametersDescription:[{anchor:"trl.PPOTrainer.log_stats.stats",description:`<strong>stats</strong> (dict[str, Any]) &#x2014;
A dictionary of training stats.`,name:"stats"},{anchor:"trl.PPOTrainer.log_stats.batch",description:`<strong>batch</strong> (dict[str, Any]) &#x2014;
A dictionary of batch data, this contains the queries and responses.`,name:"batch"},{anchor:"trl.PPOTrainer.log_stats.rewards",description:`<strong>rewards</strong> (<code>List[torch.FloatTensor]</code>) &#x2014;
A tensor of rewards.`,name:"rewards"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L1274"}}),Ae=new b({props:{name:"loss",anchor:"trl.PPOTrainer.loss",parameters:[{name:"old_logprobs",val:": FloatTensor"},{name:"values",val:": FloatTensor"},{name:"logits",val:": FloatTensor"},{name:"vpreds",val:": FloatTensor"},{name:"logprobs",val:": FloatTensor"},{name:"mask",val:": LongTensor"},{name:"advantages",val:": FloatTensor"},{name:"returns",val:": FloatTensor"}],parametersDescription:[{anchor:"trl.PPOTrainer.loss.old_logprobs",description:`<strong>old_logprobs</strong> (<code>torch.FloatTensor</code>) &#x2014;
Log probabilities of the model, shape (<code>batch_size</code>, <code>response_length</code>)`,name:"old_logprobs"},{anchor:"trl.PPOTrainer.loss.values",description:`<strong>values</strong> (<code>torch.FloatTensor</code>) &#x2014;
Values of the value head, shape (<code>batch_size</code>, <code>response_length</code>)`,name:"values"},{anchor:"trl.PPOTrainer.loss.rewards",description:`<strong>rewards</strong> (<code>torch.FloatTensor</code>) &#x2014;
Rewards from the reward model, shape (<code>batch_size</code>, <code>response_length</code>)`,name:"rewards"},{anchor:"trl.PPOTrainer.loss.logits",description:`<strong>logits</strong> (<code>torch.FloatTensor</code>) &#x2014;
Logits of the model, shape (<code>batch_size</code>, <code>response_length</code>, <code>vocab_size</code>)`,name:"logits"},{anchor:"trl.PPOTrainer.loss.v_pred",description:`<strong>v_pred</strong> (<code>torch.FloatTensor</code>) &#x2014;
Values of the value head, shape (<code>batch_size</code>, <code>response_length</code>)`,name:"v_pred"},{anchor:"trl.PPOTrainer.loss.logprobs",description:`<strong>logprobs</strong> (<code>torch.FloatTensor</code>) &#x2014;
Log probabilities of the model, shape (<code>batch_size</code>, <code>response_length</code>)`,name:"logprobs"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L1122"}}),Se=new b({props:{name:"prepare_dataloader",anchor:"trl.PPOTrainer.prepare_dataloader",parameters:[{name:"dataset",val:": typing.Union[torch.utils.data.dataset.Dataset, datasets.arrow_dataset.Dataset]"},{name:"data_collator",val:" = None"}],parametersDescription:[{anchor:"trl.PPOTrainer.prepare_dataloader.dataset",description:`<strong>dataset</strong> (Union[<code>torch.utils.data.Dataset</code>, <code>datasets.Dataset</code>]) &#x2014;
PyTorch dataset or Hugging Face dataset. If a Hugging Face dataset is passed, the dataset
will be preprocessed by removing the columns that are not used by the model.`,name:"dataset"},{anchor:"trl.PPOTrainer.prepare_dataloader.data_collator",description:`<strong>data_collator</strong> (Optional[function]) &#x2014;
Data collator function.`,name:"data_collator"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L362",returnDescription:`
<p>PyTorch dataloader</p>
`,returnType:`
<p><code>torch.utils.data.DataLoader</code></p>
`}}),qe=new b({props:{name:"record_step_stats",anchor:"trl.PPOTrainer.record_step_stats",parameters:[{name:"kl_coef",val:": float"},{name:"**data",val:""}],parametersDescription:[{anchor:"trl.PPOTrainer.record_step_stats.kl_coef",description:`<strong>kl_coef</strong> (<code>float</code>) &#x2014;
KL coefficient`,name:"kl_coef"},{anchor:"trl.PPOTrainer.record_step_stats.data",description:`<strong>data</strong> (<code>dict</code>) &#x2014;
Dictionary of training step data`,name:"data"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L1211",returnDescription:`
<p>Dictionary of training step statistics</p>
`,returnType:`
<p>stats (<code>dict</code>)</p>
`}}),Me=new b({props:{name:"step",anchor:"trl.PPOTrainer.step",parameters:[{name:"queries",val:": typing.List[torch.LongTensor]"},{name:"responses",val:": typing.List[torch.LongTensor]"},{name:"scores",val:": typing.List[torch.FloatTensor]"},{name:"response_masks",val:": typing.Optional[typing.List[torch.LongTensor]] = None"}],parametersDescription:[{anchor:"trl.PPOTrainer.step.queries",description:`<strong>queries</strong> (List<code>torch.LongTensor</code>) &#x2014;
List of tensors containing the encoded queries of shape (<code>query_length</code>)`,name:"queries"},{anchor:"trl.PPOTrainer.step.responses",description:`<strong>responses</strong> (List<code>torch.LongTensor</code>) &#x2014;
List of tensors containing the encoded responses of shape (<code>response_length</code>)`,name:"responses"},{anchor:"trl.PPOTrainer.step.scores",description:`<strong>scores</strong> (List<code>torch.FloatTensor</code>) &#x2014;
List of tensors containing the scores.`,name:"scores"},{anchor:"trl.PPOTrainer.step.response_masks",description:`<strong>response_masks</strong> (List<code>torch.FloatTensor</code>, <em>optional</em>)) &#x2014;
List of tensors containing masks of the response tokens.`,name:"response_masks"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L579",returnDescription:`
<p>A summary of the training statistics</p>
`,returnType:`
<p><code>dict[str, Any]</code></p>
`}}),Ee=new b({props:{name:"train_minibatch",anchor:"trl.PPOTrainer.train_minibatch",parameters:[{name:"old_logprobs",val:": FloatTensor"},{name:"values",val:": FloatTensor"},{name:"logprobs",val:": FloatTensor"},{name:"logits",val:": FloatTensor"},{name:"vpreds",val:": FloatTensor"},{name:"mask",val:": LongTensor"},{name:"advantages",val:": FloatTensor"},{name:"returns",val:": FloatTensor"}],parametersDescription:[{anchor:"trl.PPOTrainer.train_minibatch.logprobs",description:`<strong>logprobs</strong> (<code>torch.FloatTensor</code>) &#x2014;
Log probabilities of the model, shape [batch_size, response_length]`,name:"logprobs"},{anchor:"trl.PPOTrainer.train_minibatch.values",description:`<strong>values</strong> (<code>torch.FloatTensor</code>) &#x2014;
Values of the value head, shape [batch_size, response_length]`,name:"values"},{anchor:"trl.PPOTrainer.train_minibatch.query",description:`<strong>query</strong> (<code>torch.LongTensor</code>) &#x2014;
Encoded queries, shape [batch_size, query_length]`,name:"query"},{anchor:"trl.PPOTrainer.train_minibatch.response",description:`<strong>response</strong> (<code>torch.LongTensor</code>) &#x2014;
Encoded responses, shape [batch_size, response_length]`,name:"response"},{anchor:"trl.PPOTrainer.train_minibatch.model_input",description:`<strong>model_input</strong> (<code>torch.LongTensor</code>) &#x2014;
Concatenated queries and responses, shape [batch_size, query_length+response_length]`,name:"model_input"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L1003",returnDescription:`
<p>Dictionary of training statistics</p>
`,returnType:`
<p>train_stats (dict[str, <code>torch.Tensor</code>])</p>
`}}),Ie=new L({}),He=new b({props:{name:"class trl.RewardConfig",anchor:"trl.RewardConfig",parameters:[{name:"output_dir",val:": str"},{name:"overwrite_output_dir",val:": bool = False"},{name:"do_train",val:": bool = False"},{name:"do_eval",val:": bool = False"},{name:"do_predict",val:": bool = False"},{name:"evaluation_strategy",val:": typing.Union[transformers.trainer_utils.IntervalStrategy, str] = 'no'"},{name:"prediction_loss_only",val:": bool = False"},{name:"per_device_train_batch_size",val:": int = 8"},{name:"per_device_eval_batch_size",val:": int = 8"},{name:"per_gpu_train_batch_size",val:": typing.Optional[int] = None"},{name:"per_gpu_eval_batch_size",val:": typing.Optional[int] = None"},{name:"gradient_accumulation_steps",val:": int = 1"},{name:"eval_accumulation_steps",val:": typing.Optional[int] = None"},{name:"eval_delay",val:": typing.Optional[float] = 0"},{name:"learning_rate",val:": float = 5e-05"},{name:"weight_decay",val:": float = 0.0"},{name:"adam_beta1",val:": float = 0.9"},{name:"adam_beta2",val:": float = 0.999"},{name:"adam_epsilon",val:": float = 1e-08"},{name:"max_grad_norm",val:": float = 1.0"},{name:"num_train_epochs",val:": float = 3.0"},{name:"max_steps",val:": int = -1"},{name:"lr_scheduler_type",val:": typing.Union[transformers.trainer_utils.SchedulerType, str] = 'linear'"},{name:"warmup_ratio",val:": float = 0.0"},{name:"warmup_steps",val:": int = 0"},{name:"log_level",val:": typing.Optional[str] = 'passive'"},{name:"log_level_replica",val:": typing.Optional[str] = 'warning'"},{name:"log_on_each_node",val:": bool = True"},{name:"logging_dir",val:": typing.Optional[str] = None"},{name:"logging_strategy",val:": typing.Union[transformers.trainer_utils.IntervalStrategy, str] = 'steps'"},{name:"logging_first_step",val:": bool = False"},{name:"logging_steps",val:": float = 500"},{name:"logging_nan_inf_filter",val:": bool = True"},{name:"save_strategy",val:": typing.Union[transformers.trainer_utils.IntervalStrategy, str] = 'steps'"},{name:"save_steps",val:": float = 500"},{name:"save_total_limit",val:": typing.Optional[int] = None"},{name:"save_safetensors",val:": typing.Optional[bool] = False"},{name:"save_on_each_node",val:": bool = False"},{name:"no_cuda",val:": bool = False"},{name:"use_cpu",val:": bool = False"},{name:"use_mps_device",val:": bool = False"},{name:"seed",val:": int = 42"},{name:"data_seed",val:": typing.Optional[int] = None"},{name:"jit_mode_eval",val:": bool = False"},{name:"use_ipex",val:": bool = False"},{name:"bf16",val:": bool = False"},{name:"fp16",val:": bool = False"},{name:"fp16_opt_level",val:": str = 'O1'"},{name:"half_precision_backend",val:": str = 'auto'"},{name:"bf16_full_eval",val:": bool = False"},{name:"fp16_full_eval",val:": bool = False"},{name:"tf32",val:": typing.Optional[bool] = None"},{name:"local_rank",val:": int = -1"},{name:"ddp_backend",val:": typing.Optional[str] = None"},{name:"tpu_num_cores",val:": typing.Optional[int] = None"},{name:"tpu_metrics_debug",val:": bool = False"},{name:"debug",val:": typing.Union[str, typing.List[transformers.debug_utils.DebugOption]] = ''"},{name:"dataloader_drop_last",val:": bool = False"},{name:"eval_steps",val:": typing.Optional[float] = None"},{name:"dataloader_num_workers",val:": int = 0"},{name:"past_index",val:": int = -1"},{name:"run_name",val:": typing.Optional[str] = None"},{name:"disable_tqdm",val:": typing.Optional[bool] = None"},{name:"remove_unused_columns",val:": typing.Optional[bool] = True"},{name:"label_names",val:": typing.Optional[typing.List[str]] = None"},{name:"load_best_model_at_end",val:": typing.Optional[bool] = False"},{name:"metric_for_best_model",val:": typing.Optional[str] = None"},{name:"greater_is_better",val:": typing.Optional[bool] = None"},{name:"ignore_data_skip",val:": bool = False"},{name:"sharded_ddp",val:": typing.Union[typing.List[transformers.trainer_utils.ShardedDDPOption], str, NoneType] = ''"},{name:"fsdp",val:": typing.Union[typing.List[transformers.trainer_utils.FSDPOption], str, NoneType] = ''"},{name:"fsdp_min_num_params",val:": int = 0"},{name:"fsdp_config",val:": typing.Optional[str] = None"},{name:"fsdp_transformer_layer_cls_to_wrap",val:": typing.Optional[str] = None"},{name:"deepspeed",val:": typing.Optional[str] = None"},{name:"label_smoothing_factor",val:": float = 0.0"},{name:"optim",val:": typing.Union[transformers.training_args.OptimizerNames, str] = 'adamw_torch'"},{name:"optim_args",val:": typing.Optional[str] = None"},{name:"adafactor",val:": bool = False"},{name:"group_by_length",val:": bool = False"},{name:"length_column_name",val:": typing.Optional[str] = 'length'"},{name:"report_to",val:": typing.Optional[typing.List[str]] = None"},{name:"ddp_find_unused_parameters",val:": typing.Optional[bool] = None"},{name:"ddp_bucket_cap_mb",val:": typing.Optional[int] = None"},{name:"ddp_broadcast_buffers",val:": typing.Optional[bool] = None"},{name:"dataloader_pin_memory",val:": bool = True"},{name:"skip_memory_metrics",val:": bool = True"},{name:"use_legacy_prediction_loop",val:": bool = False"},{name:"push_to_hub",val:": bool = False"},{name:"resume_from_checkpoint",val:": typing.Optional[str] = None"},{name:"hub_model_id",val:": typing.Optional[str] = None"},{name:"hub_strategy",val:": typing.Union[transformers.trainer_utils.HubStrategy, str] = 'every_save'"},{name:"hub_token",val:": typing.Optional[str] = None"},{name:"hub_private_repo",val:": bool = False"},{name:"hub_always_push",val:": bool = False"},{name:"gradient_checkpointing",val:": typing.Optional[bool] = True"},{name:"include_inputs_for_metrics",val:": bool = False"},{name:"fp16_backend",val:": str = 'auto'"},{name:"push_to_hub_model_id",val:": typing.Optional[str] = None"},{name:"push_to_hub_organization",val:": typing.Optional[str] = None"},{name:"push_to_hub_token",val:": typing.Optional[str] = None"},{name:"mp_parameters",val:": str = ''"},{name:"auto_find_batch_size",val:": bool = False"},{name:"full_determinism",val:": bool = False"},{name:"torchdynamo",val:": typing.Optional[str] = None"},{name:"ray_scope",val:": typing.Optional[str] = 'last'"},{name:"ddp_timeout",val:": typing.Optional[int] = 1800"},{name:"torch_compile",val:": bool = False"},{name:"torch_compile_backend",val:": typing.Optional[str] = None"},{name:"torch_compile_mode",val:": typing.Optional[str] = None"},{name:"dispatch_batches",val:": typing.Optional[bool] = None"},{name:"include_tokens_per_second",val:": typing.Optional[bool] = False"},{name:"max_length",val:": typing.Optional[int] = None"}],parametersDescription:[{anchor:"trl.RewardConfig.max_length",description:`<strong>max_length</strong> (<code>int</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
The maximum length of the sequences in the batch. This argument is required if you want to use the default data collator.`,name:"max_length"},{anchor:"trl.RewardConfig.gradient_checkpointing",description:`<strong>gradient_checkpointing</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
If True, use gradient checkpointing to save memory at the expense of slower backward pass.`,name:"gradient_checkpointing"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/training_configs.py#L23"}}),Ue=new L({}),Re=new b({props:{name:"class trl.RewardTrainer",anchor:"trl.RewardTrainer",parameters:[{name:"model",val:": typing.Union[transformers.modeling_utils.PreTrainedModel, torch.nn.modules.module.Module] = None"},{name:"args",val:": typing.Optional[trl.trainer.training_configs.RewardConfig] = None"},{name:"data_collator",val:": typing.Optional[DataCollator] = None"},{name:"train_dataset",val:": typing.Optional[datasets.arrow_dataset.Dataset] = None"},{name:"eval_dataset",val:": typing.Union[datasets.arrow_dataset.Dataset, typing.Dict[str, datasets.arrow_dataset.Dataset], NoneType] = None"},{name:"tokenizer",val:": typing.Optional[transformers.tokenization_utils_base.PreTrainedTokenizerBase] = None"},{name:"model_init",val:": typing.Union[typing.Callable[[], transformers.modeling_utils.PreTrainedModel], NoneType] = None"},{name:"compute_metrics",val:": typing.Union[typing.Callable[[transformers.trainer_utils.EvalPrediction], typing.Dict], NoneType] = None"},{name:"callbacks",val:": typing.Optional[typing.List[transformers.trainer_callback.TrainerCallback]] = None"},{name:"optimizers",val:": typing.Tuple[torch.optim.optimizer.Optimizer, torch.optim.lr_scheduler.LambdaLR] = (None, None)"},{name:"preprocess_logits_for_metrics",val:": typing.Union[typing.Callable[[torch.Tensor, torch.Tensor], torch.Tensor], NoneType] = None"},{name:"max_length",val:": typing.Optional[int] = None"},{name:"peft_config",val:": typing.Optional[typing.Dict] = None"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/reward_trainer.py#L35"}}),Ve=new L({}),je=new b({props:{name:"class trl.SFTTrainer",anchor:"trl.SFTTrainer",parameters:[{name:"model",val:": typing.Union[transformers.modeling_utils.PreTrainedModel, torch.nn.modules.module.Module, str] = None"},{name:"args",val:": TrainingArguments = None"},{name:"data_collator",val:": typing.Optional[DataCollator] = None"},{name:"train_dataset",val:": typing.Optional[datasets.arrow_dataset.Dataset] = None"},{name:"eval_dataset",val:": typing.Union[datasets.arrow_dataset.Dataset, typing.Dict[str, datasets.arrow_dataset.Dataset], NoneType] = None"},{name:"tokenizer",val:": typing.Optional[transformers.tokenization_utils_base.PreTrainedTokenizerBase] = None"},{name:"model_init",val:": typing.Union[typing.Callable[[], transformers.modeling_utils.PreTrainedModel], NoneType] = None"},{name:"compute_metrics",val:": typing.Union[typing.Callable[[transformers.trainer_utils.EvalPrediction], typing.Dict], NoneType] = None"},{name:"callbacks",val:": typing.Optional[typing.List[transformers.trainer_callback.TrainerCallback]] = None"},{name:"optimizers",val:": typing.Tuple[torch.optim.optimizer.Optimizer, torch.optim.lr_scheduler.LambdaLR] = (None, None)"},{name:"preprocess_logits_for_metrics",val:": typing.Union[typing.Callable[[torch.Tensor, torch.Tensor], torch.Tensor], NoneType] = None"},{name:"peft_config",val:": typing.Optional[typing.Dict] = None"},{name:"dataset_text_field",val:": typing.Optional[str] = None"},{name:"packing",val:": typing.Optional[bool] = False"},{name:"formatting_func",val:": typing.Optional[typing.Callable] = None"},{name:"max_seq_length",val:": typing.Optional[int] = None"},{name:"infinite",val:": typing.Optional[bool] = False"},{name:"num_of_sequences",val:": typing.Optional[int] = 1024"},{name:"chars_per_token",val:": typing.Optional[float] = 3.6"},{name:"dataset_num_proc",val:": typing.Optional[int] = None"},{name:"dataset_batch_size",val:": int = 1000"}],parametersDescription:[{anchor:"trl.SFTTrainer.model",description:`<strong>model</strong> (Union[<code>transformers.PreTrainedModel</code>, <code>nn.Module</code>, <code>str</code>]) &#x2014;
The model to train, can be a <code>PreTrainedModel</code>, a <code>torch.nn.Module</code> or a string with the model name to
load from cache or download. The model can be also converted to a <code>PeftModel</code> if a <code>PeftConfig</code> object is
passed to the <code>peft_config</code> argument.`,name:"model"},{anchor:"trl.SFTTrainer.args",description:`<strong>args</strong> (Optional<a href="https://huggingface.co/docs/transformers/main/en/main_classes/trainer#transformers.TrainingArguments" rel="nofollow">transformers.TrainingArguments</a>) &#x2014;
The arguments to tweak for training. Please refer to the official documentation of <code>transformers.TrainingArguments</code>
for more information.`,name:"args"},{anchor:"trl.SFTTrainer.data_collator",description:`<strong>data_collator</strong> (Optional<code>transformers.DataCollator</code>) &#x2014;
The data collator to use for training.`,name:"data_collator"},{anchor:"trl.SFTTrainer.train_dataset",description:`<strong>train_dataset</strong> (Optional<a href="https://huggingface.co/docs/datasets/main/en/package_reference/main_classes#datasets.Dataset" rel="nofollow">datasets.Dataset</a>) &#x2014;
The dataset to use for training. We recommend users to use <code>trl.trainer.ConstantLengthDataset</code> to create their dataset.`,name:"train_dataset"},{anchor:"trl.SFTTrainer.eval_dataset",description:`<strong>eval_dataset</strong> (Optional[Union[<code>datasets.Dataset</code>, Dict[<code>str</code>, <code>datasets.Dataset</code>]]]) &#x2014;
The dataset to use for evaluation. We recommend users to use <code>trl.trainer.ConstantLengthDataset</code> to create their dataset.`,name:"eval_dataset"},{anchor:"trl.SFTTrainer.tokenizer",description:`<strong>tokenizer</strong> (Optional<a href="https://huggingface.co/docs/transformers/main/en/main_classes/tokenizer#transformers.PreTrainedTokenizer" rel="nofollow">transformers.PreTrainedTokenizer</a>) &#x2014;
The tokenizer to use for training. If not specified, the tokenizer associated to the model will be used.`,name:"tokenizer"},{anchor:"trl.SFTTrainer.model_init",description:`<strong>model_init</strong> (<code>Callable[[], transformers.PreTrainedModel]</code>) &#x2014;
The model initializer to use for training. If None is specified, the default model initializer will be used.`,name:"model_init"},{anchor:"trl.SFTTrainer.compute_metrics",description:`<strong>compute_metrics</strong> (<code>Callable[[transformers.EvalPrediction], Dict]</code>, <em>optional</em> defaults to <code>compute_accuracy</code>) &#x2014;
The metrics to use for evaluation. If no metrics are specified, the default metric (<code>compute_accuracy</code>) will be used.`,name:"compute_metrics"},{anchor:"trl.SFTTrainer.callbacks",description:`<strong>callbacks</strong> (<code>List[transformers.TrainerCallback]</code>) &#x2014;
The callbacks to use for training.`,name:"callbacks"},{anchor:"trl.SFTTrainer.optimizers",description:`<strong>optimizers</strong> (<code>Tuple[torch.optim.Optimizer, torch.optim.lr_scheduler.LambdaLR]</code>) &#x2014;
The optimizer and scheduler to use for training.`,name:"optimizers"},{anchor:"trl.SFTTrainer.preprocess_logits_for_metrics",description:`<strong>preprocess_logits_for_metrics</strong> (<code>Callable[[torch.Tensor, torch.Tensor], torch.Tensor]</code>) &#x2014;
The function to use to preprocess the logits before computing the metrics.`,name:"preprocess_logits_for_metrics"},{anchor:"trl.SFTTrainer.peft_config",description:`<strong>peft_config</strong> (<code>Optional[PeftConfig]</code>) &#x2014;
The PeftConfig object to use to initialize the PeftModel.`,name:"peft_config"},{anchor:"trl.SFTTrainer.dataset_text_field",description:`<strong>dataset_text_field</strong> (<code>Optional[str]</code>) &#x2014;
The name of the text field of the dataset, in case this is passed by a user, the trainer will automatically create a
<code>ConstantLengthDataset</code> based on the <code>dataset_text_field</code> argument.`,name:"dataset_text_field"},{anchor:"trl.SFTTrainer.formatting_func",description:`<strong>formatting_func</strong> (<code>Optional[Callable]</code>) &#x2014;
The formatting function to be used for creating the <code>ConstantLengthDataset</code>.`,name:"formatting_func"},{anchor:"trl.SFTTrainer.max_seq_length",description:`<strong>max_seq_length</strong> (<code>Optional[int]</code>) &#x2014;
The maximum sequence length to use for the <code>ConstantLengthDataset</code> and for automaticallty creating the Dataset. Defaults to <code>512</code>.`,name:"max_seq_length"},{anchor:"trl.SFTTrainer.infinite",description:`<strong>infinite</strong> (<code>Optional[bool]</code>) &#x2014;
Whether to use an infinite dataset or not. Defaults to <code>False</code>.`,name:"infinite"},{anchor:"trl.SFTTrainer.num_of_sequences",description:`<strong>num_of_sequences</strong> (<code>Optional[int]</code>) &#x2014;
The number of sequences to use for the <code>ConstantLengthDataset</code>. Defaults to <code>1024</code>.`,name:"num_of_sequences"},{anchor:"trl.SFTTrainer.chars_per_token",description:`<strong>chars_per_token</strong> (<code>Optional[float]</code>) &#x2014;
The number of characters per token to use for the <code>ConstantLengthDataset</code>. Defaults to <code>3.6</code>. You can check how this is computed in the
stack-llama example: <a href="https://github.com/huggingface/trl/blob/08f550674c553c36c51d1027613c29f14f3676a5/examples/stack_llama/scripts/supervised_finetuning.py#L53" rel="nofollow">https://github.com/huggingface/trl/blob/08f550674c553c36c51d1027613c29f14f3676a5/examples/stack_llama/scripts/supervised_finetuning.py#L53</a>.`,name:"chars_per_token"},{anchor:"trl.SFTTrainer.packing",description:`<strong>packing</strong> (<code>Optional[bool]</code>) &#x2014;
Used only in case <code>dataset_text_field</code> is passed. This argument is used by the <code>ConstantLengthDataset</code> to pack the sequences
of the dataset.`,name:"packing"},{anchor:"trl.SFTTrainer.dataset_num_proc",description:`<strong>dataset_num_proc</strong> (<code>Optional[int]</code>) &#x2014;
The number of workers to use to tokenize the data. Only used when <code>packing=False</code>. Defaults to None.`,name:"dataset_num_proc"},{anchor:"trl.SFTTrainer.dataset_batch_size",description:`<strong>dataset_batch_size</strong> (<code>int</code>) &#x2014;
The number of examples to tokenize per batch. If batch_size &lt;= 0 or batch_size == None,
tokenize the full dataset as a single batch. Defaults to 1000.`,name:"dataset_batch_size"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/sft_trainer.py#L42"}}),We=new L({}),Be=new b({props:{name:"class trl.DPOTrainer",anchor:"trl.DPOTrainer",parameters:[{name:"model",val:": typing.Union[transformers.modeling_utils.PreTrainedModel, torch.nn.modules.module.Module] = None"},{name:"ref_model",val:": typing.Union[transformers.modeling_utils.PreTrainedModel, torch.nn.modules.module.Module, NoneType] = None"},{name:"beta",val:": float = 0.1"},{name:"args",val:": TrainingArguments = None"},{name:"data_collator",val:": typing.Optional[DataCollator] = None"},{name:"label_pad_token_id",val:": int = -100"},{name:"padding_value",val:": int = 0"},{name:"truncation_mode",val:": str = 'keep_end'"},{name:"train_dataset",val:": typing.Optional[datasets.arrow_dataset.Dataset] = None"},{name:"eval_dataset",val:": typing.Union[datasets.arrow_dataset.Dataset, typing.Dict[str, datasets.arrow_dataset.Dataset], NoneType] = None"},{name:"tokenizer",val:": typing.Optional[transformers.tokenization_utils_base.PreTrainedTokenizerBase] = None"},{name:"model_init",val:": typing.Union[typing.Callable[[], transformers.modeling_utils.PreTrainedModel], NoneType] = None"},{name:"callbacks",val:": typing.Optional[typing.List[transformers.trainer_callback.TrainerCallback]] = None"},{name:"optimizers",val:": typing.Tuple[torch.optim.optimizer.Optimizer, torch.optim.lr_scheduler.LambdaLR] = (None, None)"},{name:"preprocess_logits_for_metrics",val:": typing.Union[typing.Callable[[torch.Tensor, torch.Tensor], torch.Tensor], NoneType] = None"},{name:"max_length",val:": typing.Optional[int] = None"},{name:"max_prompt_length",val:": typing.Optional[int] = None"},{name:"max_target_length",val:": typing.Optional[int] = None"},{name:"peft_config",val:": typing.Optional[typing.Dict] = None"},{name:"is_encoder_decoder",val:": typing.Optional[bool] = None"},{name:"disable_dropout",val:": bool = True"},{name:"generate_during_eval",val:": bool = False"}],parametersDescription:[{anchor:"trl.DPOTrainer.model",description:`<strong>model</strong> (<code>transformers.PreTrainedModel</code>) &#x2014;
The model to train, preferably an <code>AutoModelForSequenceClassification</code>.`,name:"model"},{anchor:"trl.DPOTrainer.ref_model",description:`<strong>ref_model</strong> (<code>PreTrainedModelWrapper</code>) &#x2014;
Hugging Face transformer model with a casual language modelling head. Used for implicit reward computation and loss. If no
reference model is provided, the trainer will create a reference model with the same architecture as the model to be optimized.`,name:"ref_model"},{anchor:"trl.DPOTrainer.beta",description:`<strong>beta</strong> (<code>float</code>, defaults to 0.1) &#x2014;
The beta factor in DPO loss. Higher beta means less divergence from the initial policy.`,name:"beta"},{anchor:"trl.DPOTrainer.args",description:`<strong>args</strong> (<code>transformers.TrainingArguments</code>) &#x2014;
The arguments to use for training.`,name:"args"},{anchor:"trl.DPOTrainer.data_collator",description:`<strong>data_collator</strong> (<code>transformers.DataCollator</code>) &#x2014;
The data collator to use for training. If None is specified, the default data collator (<code>DPODataCollatorWithPadding</code>) will be used
which will pad the sequences to the maximum length of the sequences in the batch, given a dataset of paired sequences.`,name:"data_collator"},{anchor:"trl.DPOTrainer.label_pad_token_id",description:`<strong>label_pad_token_id</strong> (<code>int</code>, defaults to <code>-100</code>) &#x2014;
The label pad token id. This argument is required if you want to use the default data collator.`,name:"label_pad_token_id"},{anchor:"trl.DPOTrainer.padding_value",description:`<strong>padding_value</strong> (<code>int</code>, defaults to <code>0</code>) &#x2014;
The padding value. This argument is required if you want to use the default data collator.`,name:"padding_value"},{anchor:"trl.DPOTrainer.truncation_mode",description:`<strong>truncation_mode</strong> (<code>str</code>, defaults to <code>keep_end</code>) &#x2014;
The truncation mode to use, either <code>keep_end</code> or <code>keep_start</code>. This argument is required if you want to use the default data collator.`,name:"truncation_mode"},{anchor:"trl.DPOTrainer.train_dataset",description:`<strong>train_dataset</strong> (<code>datasets.Dataset</code>) &#x2014;
The dataset to use for training.`,name:"train_dataset"},{anchor:"trl.DPOTrainer.eval_dataset",description:`<strong>eval_dataset</strong> (<code>datasets.Dataset</code>) &#x2014;
The dataset to use for evaluation.`,name:"eval_dataset"},{anchor:"trl.DPOTrainer.tokenizer",description:`<strong>tokenizer</strong> (<code>transformers.PreTrainedTokenizerBase</code>) &#x2014;
The tokenizer to use for training. This argument is required if you want to use the default data collator.`,name:"tokenizer"},{anchor:"trl.DPOTrainer.model_init",description:`<strong>model_init</strong> (<code>Callable[[], transformers.PreTrainedModel]</code>) &#x2014;
The model initializer to use for training. If None is specified, the default model initializer will be used.`,name:"model_init"},{anchor:"trl.DPOTrainer.callbacks",description:`<strong>callbacks</strong> (<code>List[transformers.TrainerCallback]</code>) &#x2014;
The callbacks to use for training.`,name:"callbacks"},{anchor:"trl.DPOTrainer.optimizers",description:`<strong>optimizers</strong> (<code>Tuple[torch.optim.Optimizer, torch.optim.lr_scheduler.LambdaLR]</code>) &#x2014;
The optimizer and scheduler to use for training.`,name:"optimizers"},{anchor:"trl.DPOTrainer.preprocess_logits_for_metrics",description:`<strong>preprocess_logits_for_metrics</strong> (<code>Callable[[torch.Tensor, torch.Tensor], torch.Tensor]</code>) &#x2014;
The function to use to preprocess the logits before computing the metrics.`,name:"preprocess_logits_for_metrics"},{anchor:"trl.DPOTrainer.max_length",description:`<strong>max_length</strong> (<code>int</code>, defaults to <code>None</code>) &#x2014;
The maximum length of the sequences in the batch. This argument is required if you want to use the default data collator.`,name:"max_length"},{anchor:"trl.DPOTrainer.max_prompt_length",description:`<strong>max_prompt_length</strong> (<code>int</code>, defaults to <code>None</code>) &#x2014;
The maximum length of the prompt. This argument is required if you want to use the default data collator.`,name:"max_prompt_length"},{anchor:"trl.DPOTrainer.max_target_length",description:`<strong>max_target_length</strong> (<code>int</code>, defaults to <code>None</code>) &#x2014;
The maximum length of the target. This argument is required if you want to use the default data collator and your model is an encoder-decoder.`,name:"max_target_length"},{anchor:"trl.DPOTrainer.peft_config",description:`<strong>peft_config</strong> (<code>Dict</code>, defaults to <code>None</code>) &#x2014;
The PEFT configuration to use for training. If you pass a PEFT configuration, the model will be wrapped in a PEFT model.`,name:"peft_config"},{anchor:"trl.DPOTrainer.is_encoder_decoder",description:`<strong>is_encoder_decoder</strong> (<code>Optional[bool]</code>, <code>optional</code>, defaults to <code>None</code>) &#x2014;
If no model is provided, we need to know if the model_init returns an encoder-decoder.`,name:"is_encoder_decoder"},{anchor:"trl.DPOTrainer.disable_dropout",description:`<strong>disable_dropout</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether or not to disable dropouts in <code>model</code> and <code>ref_model</code>.`,name:"disable_dropout"},{anchor:"trl.DPOTrainer.generate_during_eval",description:`<strong>generate_during_eval</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to sample and log generations during evaluation step.`,name:"generate_during_eval"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L42"}}),Ke=new b({props:{name:"concatenated_forward",anchor:"trl.DPOTrainer.concatenated_forward",parameters:[{name:"model",val:": Module"},{name:"batch",val:": typing.Dict[str, typing.Union[typing.List, torch.LongTensor]]"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L363"}}),Ge=new b({props:{name:"concatenated_inputs",anchor:"trl.DPOTrainer.concatenated_inputs",parameters:[{name:"batch",val:": typing.Dict[str, typing.Union[typing.List, torch.LongTensor]]"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L253",returnDescription:`
<p>A dictionary containing the concatenated inputs under the key ‘concatenated_input_ids’.</p>
`}}),Je=new b({props:{name:"dpo_loss",anchor:"trl.DPOTrainer.dpo_loss",parameters:[{name:"policy_chosen_logps",val:": FloatTensor"},{name:"policy_rejected_logps",val:": FloatTensor"},{name:"reference_chosen_logps",val:": FloatTensor"},{name:"reference_rejected_logps",val:": FloatTensor"},{name:"reference_free",val:": bool = False"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L292",returnDescription:`
<p>(losses, chosen_rewards, rejected_rewards).
The losses tensor contains the DPO loss for each example in the batch.
The chosen_rewards and rejected_rewards tensors contain the rewards for the chosen and rejected responses, respectively.</p>
`,returnType:`
<p>A tuple of three tensors</p>
`}}),Ye=new b({props:{name:"evaluation_loop",anchor:"trl.DPOTrainer.evaluation_loop",parameters:[{name:"dataloader",val:": DataLoader"},{name:"description",val:": str"},{name:"prediction_loss_only",val:": typing.Optional[bool] = None"},{name:"ignore_keys",val:": typing.Optional[typing.List[str]] = None"},{name:"metric_key_prefix",val:": str = 'eval'"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L554"}}),Ze=new b({props:{name:"get_batch_metrics",anchor:"trl.DPOTrainer.get_batch_metrics",parameters:[{name:"model",val:""},{name:"batch",val:": typing.Dict[str, typing.Union[typing.List, torch.LongTensor]]"},{name:"train_eval",val:": typing.Literal['train', 'eval'] = 'train'"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L401"}}),Qe=new b({props:{name:"get_batch_samples",anchor:"trl.DPOTrainer.get_batch_samples",parameters:[{name:"model",val:""},{name:"batch",val:": typing.Dict[str, torch.LongTensor]"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L474"}}),Xe=new b({props:{name:"log",anchor:"trl.DPOTrainer.log",parameters:[{name:"logs",val:": typing.Dict[str, float]"}],parametersDescription:[{anchor:"trl.DPOTrainer.log.logs",description:`<strong>logs</strong> (<code>Dict[str, float]</code>) &#x2014;
The values to log.`,name:"logs"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L603"}}),et=new L({}),tt=new b({props:{name:"class trl.DDPOConfig",anchor:"trl.DDPOConfig",parameters:[{name:"run_name",val:": typing.Optional[str] = ''"},{name:"seed",val:": typing.Optional[int] = 42"},{name:"logdir",val:": typing.Optional[str] = 'logs'"},{name:"log_with",val:": typing.Optional[str] = None"},{name:"tracker_kwargs",val:": typing.Optional[dict] = <factory>"},{name:"accelerator_kwargs",val:": typing.Optional[dict] = <factory>"},{name:"project_kwargs",val:": typing.Optional[dict] = <factory>"},{name:"tracker_project_name",val:": typing.Optional[str] = 'trl'"},{name:"num_epochs",val:": typing.Optional[int] = 100"},{name:"save_freq",val:": typing.Optional[int] = 1"},{name:"num_checkpoint_limit",val:": typing.Optional[int] = 5"},{name:"mixed_precision",val:": typing.Optional[str] = 'fp16'"},{name:"allow_tf32",val:": typing.Optional[bool] = True"},{name:"resume_from",val:": typing.Optional[str] = ''"},{name:"sample_num_steps",val:": typing.Optional[int] = 50"},{name:"sample_eta",val:": typing.Optional[float] = 1.0"},{name:"sample_guidance_scale",val:": typing.Optional[float] = 5.0"},{name:"sample_batch_size",val:": typing.Optional[int] = 1"},{name:"sample_num_batches_per_epoch",val:": typing.Optional[int] = 2"},{name:"train_batch_size",val:": typing.Optional[int] = 1"},{name:"train_use_8bit_adam",val:": typing.Optional[bool] = False"},{name:"train_learning_rate",val:": typing.Optional[float] = 0.0003"},{name:"train_adam_beta1",val:": typing.Optional[float] = 0.9"},{name:"train_adam_beta2",val:": typing.Optional[float] = 0.999"},{name:"train_adam_weight_decay",val:": typing.Optional[float] = 0.0001"},{name:"train_adam_epsilon",val:": typing.Optional[float] = 1e-08"},{name:"train_gradient_accumulation_steps",val:": typing.Optional[int] = 1"},{name:"train_max_grad_norm",val:": typing.Optional[float] = 1.0"},{name:"train_num_inner_epochs",val:": typing.Optional[int] = 1"},{name:"train_cfg",val:": typing.Optional[bool] = True"},{name:"train_adv_clip_max",val:": typing.Optional[float] = 5"},{name:"train_clip_range",val:": typing.Optional[float] = 0.0001"},{name:"train_timestep_fraction",val:": typing.Optional[float] = 1.0"},{name:"per_prompt_stat_tracking",val:": typing.Optional[bool] = False"},{name:"per_prompt_stat_tracking_buffer_size",val:": typing.Optional[int] = 16"},{name:"per_prompt_stat_tracking_min_count",val:": typing.Optional[int] = 16"},{name:"async_reward_computation",val:": typing.Optional[bool] = False"},{name:"max_workers",val:": typing.Optional[int] = 2"},{name:"negative_prompts",val:": typing.Optional[str] = ''"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ddpo_config.py#L10"}}),nt=new L({}),at=new b({props:{name:"class trl.DDPOTrainer",anchor:"trl.DDPOTrainer",parameters:[{name:"config",val:": DDPOConfig"},{name:"reward_function",val:": typing.Callable[[torch.Tensor, typing.Tuple[str], typing.Tuple[typing.Any]], torch.Tensor]"},{name:"prompt_function",val:": typing.Callable[[], typing.Tuple[str, typing.Any]]"},{name:"sd_pipeline",val:": DDPOStableDiffusionPipeline"},{name:"image_samples_hook",val:": typing.Union[typing.Callable[[typing.Any, typing.Any, typing.Any], typing.Any], NoneType] = None"}],parametersDescription:[{anchor:"trl.DDPOTrainer.*config**",description:`*<strong>*config**</strong> (<code>DDPOConfig</code>) &#x2014; Configuration object for DDPOTrainer. Check the documentation of <code>PPOConfig</code> for more &#x2014;
details.`,name:"*config**"},{anchor:"trl.DDPOTrainer.*reward_function**",description:"*<strong>*reward_function**</strong> (Callable[[torch.Tensor, Tuple[str], Tuple[Any]], torch.Tensor]) &#x2014; Reward function to be used &#x2014;",name:"*reward_function**"},{anchor:"trl.DDPOTrainer.*prompt_function**",description:"*<strong>*prompt_function**</strong> (Callable[[], Tuple[str, Any]]) &#x2014; Function to generate prompts to guide model &#x2014;",name:"*prompt_function**"},{anchor:"trl.DDPOTrainer.*sd_pipeline**",description:"*<strong>*sd_pipeline**</strong> (<code>DDPOStableDiffusionPipeline</code>) &#x2014; Stable Diffusion pipeline to be used for training. &#x2014;",name:"*sd_pipeline**"},{anchor:"trl.DDPOTrainer.*image_samples_hook**",description:"*<strong>*image_samples_hook**</strong> (Optional[Callable[[Any, Any, Any], Any]]) &#x2014; Hook to be called to log images &#x2014;",name:"*image_samples_hook**"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ddpo_trainer.py#L34"}}),rt=new b({props:{name:"calculate_loss",anchor:"trl.DDPOTrainer.calculate_loss",parameters:[{name:"latents",val:""},{name:"timesteps",val:""},{name:"next_latents",val:""},{name:"log_probs",val:""},{name:"advantages",val:""},{name:"embeds",val:""}],parametersDescription:[{anchor:"trl.DDPOTrainer.calculate_loss.latents",description:`<strong>latents</strong> (torch.Tensor) &#x2014;
The latents sampled from the diffusion model, shape: [batch_size, num_steps, &#x2026;]`,name:"latents"},{anchor:"trl.DDPOTrainer.calculate_loss.timesteps",description:`<strong>timesteps</strong> (torch.Tensor) &#x2014;
The timesteps sampled from the diffusion model, shape: [batch_size]`,name:"timesteps"},{anchor:"trl.DDPOTrainer.calculate_loss.next_latents",description:`<strong>next_latents</strong> (torch.Tensor) &#x2014;
The next latents sampled from the diffusion model, shape: [batch_size, num_steps, &#x2026;]`,name:"next_latents"},{anchor:"trl.DDPOTrainer.calculate_loss.log_probs",description:`<strong>log_probs</strong> (torch.Tensor) &#x2014;
The log probabilities of the latents, shape: [batch_size]`,name:"log_probs"},{anchor:"trl.DDPOTrainer.calculate_loss.advantages",description:`<strong>advantages</strong> (torch.Tensor) &#x2014;
The advantages of the latents, shape: [batch_size]`,name:"advantages"},{anchor:"trl.DDPOTrainer.calculate_loss.embeds",description:`<strong>embeds</strong> (torch.Tensor) &#x2014;
The embeddings of the prompts, shape: [2*batch_size or batch_size, &#x2026;]
Note: the &#x201C;or&#x201D; is because if train_cfg is True, the expectation is that negative prompts are concatenated to the embeds`,name:"embeds"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ddpo_trainer.py#L311",returnDescription:`
<p>loss (torch.Tensor), approx_kl (torch.Tensor), clipfrac (torch.Tensor)
(all of these are of shape (1,))</p>
`}}),ot=new b({props:{name:"step",anchor:"trl.DDPOTrainer.step",parameters:[{name:"epoch",val:": int"},{name:"global_step",val:": int"}],parametersDescription:[{anchor:"trl.DDPOTrainer.step.epoch",description:"<strong>epoch</strong> (int) &#x2014; The current epoch.",name:"epoch"},{anchor:"trl.DDPOTrainer.step.global_step",description:"<strong>global_step</strong> (int) &#x2014; The current global step.",name:"global_step"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ddpo_trainer.py#L205",returnDescription:`
<p>The updated global step.</p>
`,returnType:`
<p>global_step (int)</p>
`}}),st=new b({props:{name:"train",anchor:"trl.DDPOTrainer.train",parameters:[{name:"epochs",val:": typing.Optional[int] = None"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ddpo_trainer.py#L565"}}),it=new L({}),lt=new b({props:{name:"trl.set_seed",anchor:"trl.set_seed",parameters:[{name:"seed",val:": int"}],parametersDescription:[{anchor:"trl.set_seed.seed",description:"<strong>seed</strong> (<code>int</code>) &#x2014; The seed to set.",name:"seed"}],source:"https://github.com/huggingface/trl/blob/main/trl/core.py#L233"}}),{c(){z=n("meta"),fn=o(),F=n("h1"),K=n("a"),sn=n("span"),p(Pe.$$.fragment),ua=o(),dt=n("span"),dt.textContent=zr,vn=o(),xe=n("p"),xe.innerHTML=Fr,bn=o(),A=n("h2"),G=n("a"),ln=n("span"),p(Oe.$$.fragment),fa=o(),ct=n("span"),ct.textContent=Ar,Tn=o(),S=n("div"),p($e.$$.fragment),va=o(),pt=n("p"),pt.textContent=Sr,yn=o(),q=n("h2"),J=n("a"),dn=n("span"),p(we.$$.fragment),ba=o(),mt=n("span"),mt.textContent=qr,Pn=o(),v=n("div"),p(De.$$.fragment),Ta=o(),gt=n("p"),gt.innerHTML=Mr,ya=o(),Y=n("div"),p(Ce.$$.fragment),Pa=o(),ht=n("p"),ht.textContent=Er,xa=o(),Z=n("div"),p(ke.$$.fragment),Oa=o(),_t=n("p"),_t.textContent=Ir,$a=o(),Q=n("div"),p(Ne.$$.fragment),wa=o(),ut=n("p"),ut.textContent=Hr,Da=o(),X=n("div"),p(Le.$$.fragment),Ca=o(),ft=n("p"),ft.textContent=Ur,ka=o(),ee=n("div"),p(ze.$$.fragment),Na=o(),vt=n("p"),vt.innerHTML=Rr,La=o(),te=n("div"),p(Fe.$$.fragment),za=o(),bt=n("p"),bt.textContent=Vr,Fa=o(),ne=n("div"),p(Ae.$$.fragment),Aa=o(),Tt=n("p"),Tt.textContent=jr,Sa=o(),ae=n("div"),p(Se.$$.fragment),qa=o(),yt=n("p"),yt.textContent=Wr,Ma=o(),re=n("div"),p(qe.$$.fragment),Ea=o(),Pt=n("p"),Pt.textContent=Br,Ia=o(),oe=n("div"),p(Me.$$.fragment),Ha=o(),xt=n("p"),xt.textContent=Kr,Ua=o(),se=n("div"),p(Ee.$$.fragment),Ra=o(),Ot=n("p"),Ot.textContent=Gr,xn=o(),M=n("h2"),ie=n("a"),cn=n("span"),p(Ie.$$.fragment),Va=o(),$t=n("span"),$t.textContent=Jr,On=o(),w=n("div"),p(He.$$.fragment),ja=o(),wt=n("p"),wt.innerHTML=Yr,Wa=o(),Dt=n("p"),Dt.innerHTML=Zr,$n=o(),E=n("h2"),le=n("a"),pn=n("span"),p(Ue.$$.fragment),Ba=o(),Ct=n("span"),Ct.textContent=Qr,wn=o(),x=n("div"),p(Re.$$.fragment),Ka=o(),kt=n("p"),kt.innerHTML=Xr,Ga=o(),Nt=n("p"),Nt.innerHTML=eo,Ja=o(),Lt=n("ul"),Lt.innerHTML=to,Ya=o(),zt=n("p"),zt.innerHTML=no,Dn=o(),I=n("h2"),de=n("a"),mn=n("span"),p(Ve.$$.fragment),Za=o(),Ft=n("span"),Ft.textContent=ao,Cn=o(),H=n("div"),p(je.$$.fragment),Qa=o(),At=n("p"),At.innerHTML=ro,kn=o(),U=n("h2"),ce=n("a"),gn=n("span"),p(We.$$.fragment),Xa=o(),St=n("span"),St.textContent=oo,Nn=o(),y=n("div"),p(Be.$$.fragment),er=o(),qt=n("p"),qt.textContent=so,tr=o(),D=n("div"),p(Ke.$$.fragment),nr=o(),Mt=n("p"),Mt.textContent=io,ar=o(),Et=n("p"),Et.textContent=lo,rr=o(),pe=n("div"),p(Ge.$$.fragment),or=o(),It=n("p"),It.textContent=co,sr=o(),me=n("div"),p(Je.$$.fragment),ir=o(),Ht=n("p"),Ht.textContent=po,lr=o(),C=n("div"),p(Ye.$$.fragment),dr=o(),Ut=n("p"),Ut.innerHTML=mo,cr=o(),Rt=n("p"),Rt.textContent=go,pr=o(),ge=n("div"),p(Ze.$$.fragment),mr=o(),Vt=n("p"),Vt.textContent=ho,gr=o(),he=n("div"),p(Qe.$$.fragment),hr=o(),jt=n("p"),jt.textContent=_o,_r=o(),_e=n("div"),p(Xe.$$.fragment),ur=o(),Wt=n("p"),Wt.innerHTML=uo,Ln=o(),R=n("h2"),ue=n("a"),hn=n("span"),p(et.$$.fragment),fr=o(),Bt=n("span"),Bt.textContent=fo,zn=o(),V=n("div"),p(tt.$$.fragment),vr=o(),Kt=n("p"),Kt.textContent=vo,Fn=o(),j=n("h2"),fe=n("a"),_n=n("span"),p(nt.$$.fragment),br=o(),Gt=n("span"),Gt.textContent=bo,An=o(),O=n("div"),p(at.$$.fragment),Tr=o(),Jt=n("p"),Jt.innerHTML=To,yr=o(),ve=n("div"),p(rt.$$.fragment),Pr=o(),Yt=n("p"),Yt.textContent=yo,xr=o(),$=n("div"),p(ot.$$.fragment),Or=o(),Zt=n("p"),Zt.textContent=Po,$r=o(),Qt=n("p"),Qt.textContent=xo,wr=o(),Xt=n("ul"),Xt.innerHTML=Oo,Dr=o(),be=n("div"),p(st.$$.fragment),Cr=o(),en=n("p"),en.textContent=$o,Sn=o(),W=n("h2"),Te=n("a"),un=n("span"),p(it.$$.fragment),kr=o(),tn=n("span"),tn.textContent=wo,qn=o(),B=n("div"),p(lt.$$.fragment),Nr=o(),nn=n("p"),nn.innerHTML=Do,this.h()},l(e){const c=Xo("svelte-1phssyn",document.head);z=a(c,"META",{name:!0,content:!0}),c.forEach(r),fn=s(e),F=a(e,"H1",{class:!0});var En=l(F);K=a(En,"A",{id:!0,class:!0,href:!0});var Co=l(K);sn=a(Co,"SPAN",{});var ko=l(sn);m(Pe.$$.fragment,ko),ko.forEach(r),Co.forEach(r),ua=s(En),dt=a(En,"SPAN",{"data-svelte-h":!0}),d(dt)!=="svelte-1db8bfa"&&(dt.textContent=zr),En.forEach(r),vn=s(e),xe=a(e,"P",{"data-svelte-h":!0}),d(xe)!=="svelte-dxrcnp"&&(xe.innerHTML=Fr),bn=s(e),A=a(e,"H2",{class:!0});var In=l(A);G=a(In,"A",{id:!0,class:!0,href:!0});var No=l(G);ln=a(No,"SPAN",{});var Lo=l(ln);m(Oe.$$.fragment,Lo),Lo.forEach(r),No.forEach(r),fa=s(In),ct=a(In,"SPAN",{"data-svelte-h":!0}),d(ct)!=="svelte-1vvizjw"&&(ct.textContent=Ar),In.forEach(r),Tn=s(e),S=a(e,"DIV",{class:!0});var Hn=l(S);m($e.$$.fragment,Hn),va=s(Hn),pt=a(Hn,"P",{"data-svelte-h":!0}),d(pt)!=="svelte-aondqr"&&(pt.textContent=Sr),Hn.forEach(r),yn=s(e),q=a(e,"H2",{class:!0});var Un=l(q);J=a(Un,"A",{id:!0,class:!0,href:!0});var zo=l(J);dn=a(zo,"SPAN",{});var Fo=l(dn);m(we.$$.fragment,Fo),Fo.forEach(r),zo.forEach(r),ba=s(Un),mt=a(Un,"SPAN",{"data-svelte-h":!0}),d(mt)!=="svelte-fxm3n"&&(mt.textContent=qr),Un.forEach(r),Pn=s(e),v=a(e,"DIV",{class:!0});var T=l(v);m(De.$$.fragment,T),Ta=s(T),gt=a(T,"P",{"data-svelte-h":!0}),d(gt)!=="svelte-hys9rl"&&(gt.innerHTML=Mr),ya=s(T),Y=a(T,"DIV",{class:!0});var Rn=l(Y);m(Ce.$$.fragment,Rn),Pa=s(Rn),ht=a(Rn,"P",{"data-svelte-h":!0}),d(ht)!=="svelte-185nst0"&&(ht.textContent=Er),Rn.forEach(r),xa=s(T),Z=a(T,"DIV",{class:!0});var Vn=l(Z);m(ke.$$.fragment,Vn),Oa=s(Vn),_t=a(Vn,"P",{"data-svelte-h":!0}),d(_t)!=="svelte-3nt516"&&(_t.textContent=Ir),Vn.forEach(r),$a=s(T),Q=a(T,"DIV",{class:!0});var jn=l(Q);m(Ne.$$.fragment,jn),wa=s(jn),ut=a(jn,"P",{"data-svelte-h":!0}),d(ut)!=="svelte-3jfrz9"&&(ut.textContent=Hr),jn.forEach(r),Da=s(T),X=a(T,"DIV",{class:!0});var Wn=l(X);m(Le.$$.fragment,Wn),Ca=s(Wn),ft=a(Wn,"P",{"data-svelte-h":!0}),d(ft)!=="svelte-lcc1u3"&&(ft.textContent=Ur),Wn.forEach(r),ka=s(T),ee=a(T,"DIV",{class:!0});var Bn=l(ee);m(ze.$$.fragment,Bn),Na=s(Bn),vt=a(Bn,"P",{"data-svelte-h":!0}),d(vt)!=="svelte-1gqqzmu"&&(vt.innerHTML=Rr),Bn.forEach(r),La=s(T),te=a(T,"DIV",{class:!0});var Kn=l(te);m(Fe.$$.fragment,Kn),za=s(Kn),bt=a(Kn,"P",{"data-svelte-h":!0}),d(bt)!=="svelte-ffqz5"&&(bt.textContent=Vr),Kn.forEach(r),Fa=s(T),ne=a(T,"DIV",{class:!0});var Gn=l(ne);m(Ae.$$.fragment,Gn),Aa=s(Gn),Tt=a(Gn,"P",{"data-svelte-h":!0}),d(Tt)!=="svelte-febvhf"&&(Tt.textContent=jr),Gn.forEach(r),Sa=s(T),ae=a(T,"DIV",{class:!0});var Jn=l(ae);m(Se.$$.fragment,Jn),qa=s(Jn),yt=a(Jn,"P",{"data-svelte-h":!0}),d(yt)!=="svelte-1hbodkw"&&(yt.textContent=Wr),Jn.forEach(r),Ma=s(T),re=a(T,"DIV",{class:!0});var Yn=l(re);m(qe.$$.fragment,Yn),Ea=s(Yn),Pt=a(Yn,"P",{"data-svelte-h":!0}),d(Pt)!=="svelte-1hfgx92"&&(Pt.textContent=Br),Yn.forEach(r),Ia=s(T),oe=a(T,"DIV",{class:!0});var Zn=l(oe);m(Me.$$.fragment,Zn),Ha=s(Zn),xt=a(Zn,"P",{"data-svelte-h":!0}),d(xt)!=="svelte-yrsdu6"&&(xt.textContent=Kr),Zn.forEach(r),Ua=s(T),se=a(T,"DIV",{class:!0});var Qn=l(se);m(Ee.$$.fragment,Qn),Ra=s(Qn),Ot=a(Qn,"P",{"data-svelte-h":!0}),d(Ot)!=="svelte-3k7k5e"&&(Ot.textContent=Gr),Qn.forEach(r),T.forEach(r),xn=s(e),M=a(e,"H2",{class:!0});var Xn=l(M);ie=a(Xn,"A",{id:!0,class:!0,href:!0});var Ao=l(ie);cn=a(Ao,"SPAN",{});var So=l(cn);m(Ie.$$.fragment,So),So.forEach(r),Ao.forEach(r),Va=s(Xn),$t=a(Xn,"SPAN",{"data-svelte-h":!0}),d($t)!=="svelte-j3b116"&&($t.textContent=Jr),Xn.forEach(r),On=s(e),w=a(e,"DIV",{class:!0});var an=l(w);m(He.$$.fragment,an),ja=s(an),wt=a(an,"P",{"data-svelte-h":!0}),d(wt)!=="svelte-u4tkv1"&&(wt.innerHTML=Yr),Wa=s(an),Dt=a(an,"P",{"data-svelte-h":!0}),d(Dt)!=="svelte-1xl7jqc"&&(Dt.innerHTML=Zr),an.forEach(r),$n=s(e),E=a(e,"H2",{class:!0});var ea=l(E);le=a(ea,"A",{id:!0,class:!0,href:!0});var qo=l(le);pn=a(qo,"SPAN",{});var Mo=l(pn);m(Ue.$$.fragment,Mo),Mo.forEach(r),qo.forEach(r),Ba=s(ea),Ct=a(ea,"SPAN",{"data-svelte-h":!0}),d(Ct)!=="svelte-1xrti1v"&&(Ct.textContent=Qr),ea.forEach(r),wn=s(e),x=a(e,"DIV",{class:!0});var k=l(x);m(Re.$$.fragment,k),Ka=s(k),kt=a(k,"P",{"data-svelte-h":!0}),d(kt)!=="svelte-qafafj"&&(kt.innerHTML=Xr),Ga=s(k),Nt=a(k,"P",{"data-svelte-h":!0}),d(Nt)!=="svelte-bkmbwh"&&(Nt.innerHTML=eo),Ja=s(k),Lt=a(k,"UL",{"data-svelte-h":!0}),d(Lt)!=="svelte-1ytuxgw"&&(Lt.innerHTML=to),Ya=s(k),zt=a(k,"P",{"data-svelte-h":!0}),d(zt)!=="svelte-18tbp4c"&&(zt.innerHTML=no),k.forEach(r),Dn=s(e),I=a(e,"H2",{class:!0});var ta=l(I);de=a(ta,"A",{id:!0,class:!0,href:!0});var Eo=l(de);mn=a(Eo,"SPAN",{});var Io=l(mn);m(Ve.$$.fragment,Io),Io.forEach(r),Eo.forEach(r),Za=s(ta),Ft=a(ta,"SPAN",{"data-svelte-h":!0}),d(Ft)!=="svelte-9e8rqt"&&(Ft.textContent=ao),ta.forEach(r),Cn=s(e),H=a(e,"DIV",{class:!0});var na=l(H);m(je.$$.fragment,na),Qa=s(na),At=a(na,"P",{"data-svelte-h":!0}),d(At)!=="svelte-14oyph8"&&(At.innerHTML=ro),na.forEach(r),kn=s(e),U=a(e,"H2",{class:!0});var aa=l(U);ce=a(aa,"A",{id:!0,class:!0,href:!0});var Ho=l(ce);gn=a(Ho,"SPAN",{});var Uo=l(gn);m(We.$$.fragment,Uo),Uo.forEach(r),Ho.forEach(r),Xa=s(aa),St=a(aa,"SPAN",{"data-svelte-h":!0}),d(St)!=="svelte-z1ki3z"&&(St.textContent=oo),aa.forEach(r),Nn=s(e),y=a(e,"DIV",{class:!0});var P=l(y);m(Be.$$.fragment,P),er=s(P),qt=a(P,"P",{"data-svelte-h":!0}),d(qt)!=="svelte-n6cc8y"&&(qt.textContent=so),tr=s(P),D=a(P,"DIV",{class:!0});var rn=l(D);m(Ke.$$.fragment,rn),nr=s(rn),Mt=a(rn,"P",{"data-svelte-h":!0}),d(Mt)!=="svelte-16i1nac"&&(Mt.textContent=io),ar=s(rn),Et=a(rn,"P",{"data-svelte-h":!0}),d(Et)!=="svelte-tgti68"&&(Et.textContent=lo),rn.forEach(r),rr=s(P),pe=a(P,"DIV",{class:!0});var ra=l(pe);m(Ge.$$.fragment,ra),or=s(ra),It=a(ra,"P",{"data-svelte-h":!0}),d(It)!=="svelte-1cvsgkk"&&(It.textContent=co),ra.forEach(r),sr=s(P),me=a(P,"DIV",{class:!0});var oa=l(me);m(Je.$$.fragment,oa),ir=s(oa),Ht=a(oa,"P",{"data-svelte-h":!0}),d(Ht)!=="svelte-ymgxq7"&&(Ht.textContent=po),oa.forEach(r),lr=s(P),C=a(P,"DIV",{class:!0});var on=l(C);m(Ye.$$.fragment,on),dr=s(on),Ut=a(on,"P",{"data-svelte-h":!0}),d(Ut)!=="svelte-8qlty5"&&(Ut.innerHTML=mo),cr=s(on),Rt=a(on,"P",{"data-svelte-h":!0}),d(Rt)!=="svelte-1tyo99t"&&(Rt.textContent=go),on.forEach(r),pr=s(P),ge=a(P,"DIV",{class:!0});var sa=l(ge);m(Ze.$$.fragment,sa),mr=s(sa),Vt=a(sa,"P",{"data-svelte-h":!0}),d(Vt)!=="svelte-11q8u7l"&&(Vt.textContent=ho),sa.forEach(r),gr=s(P),he=a(P,"DIV",{class:!0});var ia=l(he);m(Qe.$$.fragment,ia),hr=s(ia),jt=a(ia,"P",{"data-svelte-h":!0}),d(jt)!=="svelte-18uwvbi"&&(jt.textContent=_o),ia.forEach(r),_r=s(P),_e=a(P,"DIV",{class:!0});var la=l(_e);m(Xe.$$.fragment,la),ur=s(la),Wt=a(la,"P",{"data-svelte-h":!0}),d(Wt)!=="svelte-nqksfz"&&(Wt.innerHTML=uo),la.forEach(r),P.forEach(r),Ln=s(e),R=a(e,"H2",{class:!0});var da=l(R);ue=a(da,"A",{id:!0,class:!0,href:!0});var Ro=l(ue);hn=a(Ro,"SPAN",{});var Vo=l(hn);m(et.$$.fragment,Vo),Vo.forEach(r),Ro.forEach(r),fr=s(da),Bt=a(da,"SPAN",{"data-svelte-h":!0}),d(Bt)!=="svelte-1ou3lbs"&&(Bt.textContent=fo),da.forEach(r),zn=s(e),V=a(e,"DIV",{class:!0});var ca=l(V);m(tt.$$.fragment,ca),vr=s(ca),Kt=a(ca,"P",{"data-svelte-h":!0}),d(Kt)!=="svelte-2zpx1f"&&(Kt.textContent=vo),ca.forEach(r),Fn=s(e),j=a(e,"H2",{class:!0});var pa=l(j);fe=a(pa,"A",{id:!0,class:!0,href:!0});var jo=l(fe);_n=a(jo,"SPAN",{});var Wo=l(_n);m(nt.$$.fragment,Wo),Wo.forEach(r),jo.forEach(r),br=s(pa),Gt=a(pa,"SPAN",{"data-svelte-h":!0}),d(Gt)!=="svelte-c3466p"&&(Gt.textContent=bo),pa.forEach(r),An=s(e),O=a(e,"DIV",{class:!0});var N=l(O);m(at.$$.fragment,N),Tr=s(N),Jt=a(N,"P",{"data-svelte-h":!0}),d(Jt)!=="svelte-8q861t"&&(Jt.innerHTML=To),yr=s(N),ve=a(N,"DIV",{class:!0});var ma=l(ve);m(rt.$$.fragment,ma),Pr=s(ma),Yt=a(ma,"P",{"data-svelte-h":!0}),d(Yt)!=="svelte-1ag17u3"&&(Yt.textContent=yo),ma.forEach(r),xr=s(N),$=a(N,"DIV",{class:!0});var ye=l($);m(ot.$$.fragment,ye),Or=s(ye),Zt=a(ye,"P",{"data-svelte-h":!0}),d(Zt)!=="svelte-r6y15n"&&(Zt.textContent=Po),$r=s(ye),Qt=a(ye,"P",{"data-svelte-h":!0}),d(Qt)!=="svelte-imqqfp"&&(Qt.textContent=xo),wr=s(ye),Xt=a(ye,"UL",{"data-svelte-h":!0}),d(Xt)!=="svelte-105j238"&&(Xt.innerHTML=Oo),ye.forEach(r),Dr=s(N),be=a(N,"DIV",{class:!0});var ga=l(be);m(st.$$.fragment,ga),Cr=s(ga),en=a(ga,"P",{"data-svelte-h":!0}),d(en)!=="svelte-1an944l"&&(en.textContent=$o),ga.forEach(r),N.forEach(r),Sn=s(e),W=a(e,"H2",{class:!0});var ha=l(W);Te=a(ha,"A",{id:!0,class:!0,href:!0});var Bo=l(Te);un=a(Bo,"SPAN",{});var Ko=l(un);m(it.$$.fragment,Ko),Ko.forEach(r),Bo.forEach(r),kr=s(ha),tn=a(ha,"SPAN",{"data-svelte-h":!0}),d(tn)!=="svelte-1nghy41"&&(tn.textContent=wo),ha.forEach(r),qn=s(e),B=a(e,"DIV",{class:!0});var _a=l(B);m(lt.$$.fragment,_a),Nr=s(_a),nn=a(_a,"P",{"data-svelte-h":!0}),d(nn)!=="svelte-1aeuhep"&&(nn.innerHTML=Do),_a.forEach(r),this.h()},h(){i(z,"name","hf:doc:metadata"),i(z,"content",JSON.stringify(ts)),i(K,"id","trainer"),i(K,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(K,"href","#trainer"),i(F,"class","relative group"),i(G,"id","trl.PPOConfig"),i(G,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(G,"href","#trl.PPOConfig"),i(A,"class","relative group"),i(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(J,"id","trl.PPOTrainer"),i(J,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(J,"href","#trl.PPOTrainer"),i(q,"class","relative group"),i(Y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(Z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(Q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(X,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(ee,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(te,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(ne,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(ae,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(re,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(oe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(ie,"id","trl.RewardConfig"),i(ie,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(ie,"href","#trl.RewardConfig"),i(M,"class","relative group"),i(w,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(le,"id","trl.RewardTrainer"),i(le,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(le,"href","#trl.RewardTrainer"),i(E,"class","relative group"),i(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(de,"id","trl.SFTTrainer"),i(de,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(de,"href","#trl.SFTTrainer"),i(I,"class","relative group"),i(H,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(ce,"id","trl.DPOTrainer"),i(ce,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(ce,"href","#trl.DPOTrainer"),i(U,"class","relative group"),i(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(pe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(me,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(ge,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(he,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(_e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(ue,"id","trl.DDPOConfig"),i(ue,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(ue,"href","#trl.DDPOConfig"),i(R,"class","relative group"),i(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(fe,"id","trl.DDPOTrainer"),i(fe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(fe,"href","#trl.DDPOTrainer"),i(j,"class","relative group"),i(ve,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(be,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(O,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(Te,"id","trl.set_seed"),i(Te,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Te,"href","#trl.set_seed"),i(W,"class","relative group"),i(B,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,c){t(document.head,z),g(e,fn,c),g(e,F,c),t(F,K),t(K,sn),h(Pe,sn,null),t(F,ua),t(F,dt),g(e,vn,c),g(e,xe,c),g(e,bn,c),g(e,A,c),t(A,G),t(G,ln),h(Oe,ln,null),t(A,fa),t(A,ct),g(e,Tn,c),g(e,S,c),h($e,S,null),t(S,va),t(S,pt),g(e,yn,c),g(e,q,c),t(q,J),t(J,dn),h(we,dn,null),t(q,ba),t(q,mt),g(e,Pn,c),g(e,v,c),h(De,v,null),t(v,Ta),t(v,gt),t(v,ya),t(v,Y),h(Ce,Y,null),t(Y,Pa),t(Y,ht),t(v,xa),t(v,Z),h(ke,Z,null),t(Z,Oa),t(Z,_t),t(v,$a),t(v,Q),h(Ne,Q,null),t(Q,wa),t(Q,ut),t(v,Da),t(v,X),h(Le,X,null),t(X,Ca),t(X,ft),t(v,ka),t(v,ee),h(ze,ee,null),t(ee,Na),t(ee,vt),t(v,La),t(v,te),h(Fe,te,null),t(te,za),t(te,bt),t(v,Fa),t(v,ne),h(Ae,ne,null),t(ne,Aa),t(ne,Tt),t(v,Sa),t(v,ae),h(Se,ae,null),t(ae,qa),t(ae,yt),t(v,Ma),t(v,re),h(qe,re,null),t(re,Ea),t(re,Pt),t(v,Ia),t(v,oe),h(Me,oe,null),t(oe,Ha),t(oe,xt),t(v,Ua),t(v,se),h(Ee,se,null),t(se,Ra),t(se,Ot),g(e,xn,c),g(e,M,c),t(M,ie),t(ie,cn),h(Ie,cn,null),t(M,Va),t(M,$t),g(e,On,c),g(e,w,c),h(He,w,null),t(w,ja),t(w,wt),t(w,Wa),t(w,Dt),g(e,$n,c),g(e,E,c),t(E,le),t(le,pn),h(Ue,pn,null),t(E,Ba),t(E,Ct),g(e,wn,c),g(e,x,c),h(Re,x,null),t(x,Ka),t(x,kt),t(x,Ga),t(x,Nt),t(x,Ja),t(x,Lt),t(x,Ya),t(x,zt),g(e,Dn,c),g(e,I,c),t(I,de),t(de,mn),h(Ve,mn,null),t(I,Za),t(I,Ft),g(e,Cn,c),g(e,H,c),h(je,H,null),t(H,Qa),t(H,At),g(e,kn,c),g(e,U,c),t(U,ce),t(ce,gn),h(We,gn,null),t(U,Xa),t(U,St),g(e,Nn,c),g(e,y,c),h(Be,y,null),t(y,er),t(y,qt),t(y,tr),t(y,D),h(Ke,D,null),t(D,nr),t(D,Mt),t(D,ar),t(D,Et),t(y,rr),t(y,pe),h(Ge,pe,null),t(pe,or),t(pe,It),t(y,sr),t(y,me),h(Je,me,null),t(me,ir),t(me,Ht),t(y,lr),t(y,C),h(Ye,C,null),t(C,dr),t(C,Ut),t(C,cr),t(C,Rt),t(y,pr),t(y,ge),h(Ze,ge,null),t(ge,mr),t(ge,Vt),t(y,gr),t(y,he),h(Qe,he,null),t(he,hr),t(he,jt),t(y,_r),t(y,_e),h(Xe,_e,null),t(_e,ur),t(_e,Wt),g(e,Ln,c),g(e,R,c),t(R,ue),t(ue,hn),h(et,hn,null),t(R,fr),t(R,Bt),g(e,zn,c),g(e,V,c),h(tt,V,null),t(V,vr),t(V,Kt),g(e,Fn,c),g(e,j,c),t(j,fe),t(fe,_n),h(nt,_n,null),t(j,br),t(j,Gt),g(e,An,c),g(e,O,c),h(at,O,null),t(O,Tr),t(O,Jt),t(O,yr),t(O,ve),h(rt,ve,null),t(ve,Pr),t(ve,Yt),t(O,xr),t(O,$),h(ot,$,null),t($,Or),t($,Zt),t($,$r),t($,Qt),t($,wr),t($,Xt),t(O,Dr),t(O,be),h(st,be,null),t(be,Cr),t(be,en),g(e,Sn,c),g(e,W,c),t(W,Te),t(Te,un),h(it,un,null),t(W,kr),t(W,tn),g(e,qn,c),g(e,B,c),h(lt,B,null),t(B,Nr),t(B,nn),Mn=!0},p:Jo,i(e){Mn||(_(Pe.$$.fragment,e),_(Oe.$$.fragment,e),_($e.$$.fragment,e),_(we.$$.fragment,e),_(De.$$.fragment,e),_(Ce.$$.fragment,e),_(ke.$$.fragment,e),_(Ne.$$.fragment,e),_(Le.$$.fragment,e),_(ze.$$.fragment,e),_(Fe.$$.fragment,e),_(Ae.$$.fragment,e),_(Se.$$.fragment,e),_(qe.$$.fragment,e),_(Me.$$.fragment,e),_(Ee.$$.fragment,e),_(Ie.$$.fragment,e),_(He.$$.fragment,e),_(Ue.$$.fragment,e),_(Re.$$.fragment,e),_(Ve.$$.fragment,e),_(je.$$.fragment,e),_(We.$$.fragment,e),_(Be.$$.fragment,e),_(Ke.$$.fragment,e),_(Ge.$$.fragment,e),_(Je.$$.fragment,e),_(Ye.$$.fragment,e),_(Ze.$$.fragment,e),_(Qe.$$.fragment,e),_(Xe.$$.fragment,e),_(et.$$.fragment,e),_(tt.$$.fragment,e),_(nt.$$.fragment,e),_(at.$$.fragment,e),_(rt.$$.fragment,e),_(ot.$$.fragment,e),_(st.$$.fragment,e),_(it.$$.fragment,e),_(lt.$$.fragment,e),Mn=!0)},o(e){u(Pe.$$.fragment,e),u(Oe.$$.fragment,e),u($e.$$.fragment,e),u(we.$$.fragment,e),u(De.$$.fragment,e),u(Ce.$$.fragment,e),u(ke.$$.fragment,e),u(Ne.$$.fragment,e),u(Le.$$.fragment,e),u(ze.$$.fragment,e),u(Fe.$$.fragment,e),u(Ae.$$.fragment,e),u(Se.$$.fragment,e),u(qe.$$.fragment,e),u(Me.$$.fragment,e),u(Ee.$$.fragment,e),u(Ie.$$.fragment,e),u(He.$$.fragment,e),u(Ue.$$.fragment,e),u(Re.$$.fragment,e),u(Ve.$$.fragment,e),u(je.$$.fragment,e),u(We.$$.fragment,e),u(Be.$$.fragment,e),u(Ke.$$.fragment,e),u(Ge.$$.fragment,e),u(Je.$$.fragment,e),u(Ye.$$.fragment,e),u(Ze.$$.fragment,e),u(Qe.$$.fragment,e),u(Xe.$$.fragment,e),u(et.$$.fragment,e),u(tt.$$.fragment,e),u(nt.$$.fragment,e),u(at.$$.fragment,e),u(rt.$$.fragment,e),u(ot.$$.fragment,e),u(st.$$.fragment,e),u(it.$$.fragment,e),u(lt.$$.fragment,e),Mn=!1},d(e){e&&(r(fn),r(F),r(vn),r(xe),r(bn),r(A),r(Tn),r(S),r(yn),r(q),r(Pn),r(v),r(xn),r(M),r(On),r(w),r($n),r(E),r(wn),r(x),r(Dn),r(I),r(Cn),r(H),r(kn),r(U),r(Nn),r(y),r(Ln),r(R),r(zn),r(V),r(Fn),r(j),r(An),r(O),r(Sn),r(W),r(qn),r(B)),r(z),f(Pe),f(Oe),f($e),f(we),f(De),f(Ce),f(ke),f(Ne),f(Le),f(ze),f(Fe),f(Ae),f(Se),f(qe),f(Me),f(Ee),f(Ie),f(He),f(Ue),f(Re),f(Ve),f(je),f(We),f(Be),f(Ke),f(Ge),f(Je),f(Ye),f(Ze),f(Qe),f(Xe),f(et),f(tt),f(nt),f(at),f(rt),f(ot),f(st),f(it),f(lt)}}}const ts={local:"trainer",sections:[{local:"trl.PPOConfig",title:"PPOConfig"},{local:"trl.PPOTrainer",title:"PPOTrainer"},{local:"trl.RewardConfig",title:"RewardConfig"},{local:"trl.RewardTrainer",title:"RewardTrainer"},{local:"trl.SFTTrainer",title:"SFTTrainer"},{local:"trl.DPOTrainer",title:"DPOTrainer"},{local:"trl.DDPOConfig",title:"DDPOConfig"},{local:"trl.DDPOTrainer",title:"DDPOTrainer"},{local:"trl.set_seed",title:"set_seed"}],title:"Trainer"};function ns(Lr){return Yo(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class is extends Zo{constructor(z){super(),Qo(this,z,ns,es,Go,{})}}export{is as component};
